import math

n = int(input())
points = []
groups = []

for _ in range(n*2):
    x, y = map(int, input().split())
    points.append([x, y])

for point_1 in points:
    closest_distance = float('inf')
    closest_point = []
    for point_2 in points:
        if point_1 != point_2:
            distance = int(math.fabs(point_1[0]-point_2[0])+math.fabs(point_1[1]-point_2[1]))
            if distance < closest_distance:
                closest_point = point_2
                closest_distance = distance
    groups.append([point_1, closest_point])

max_dist = 0
for group in groups:
    distance = int(math.fabs(group[0][0]-group[1][0])+math.fabs(group[0][1]-group[1][1]))
    if distance > max_dist:
        max_dist = distance

print(max_dist)