import math

n = int(input())
points = []
groups = []

for _ in range(n*2):
    x, y = map(int, input().split())
    points.append([x, y])

for i in range(len(points)):
    closest_distance = float('inf')
    closest_point = []
    for j in range(len(points)):
        if i != j:
            distance = int(math.fabs(points[i][0]-points[j][0])+math.fabs(points[i][1]-points[j][1]))
            if distance == 0:
                continue
            if distance < closest_distance:
                closest_point = points[j]
                closest_distance = distance
    groups.append([points[i], closest_point])

max_dist = 0
for group in groups:
    distance = int(math.fabs(group[0][0]-group[1][0])+math.fabs(group[0][1]-group[1][1]))
    if distance >= max_dist:
        max_dist = distance

print(max_dist)