import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Task22 {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer(br.readLine());
        int n = Integer.parseInt(st.nextToken());
        int m = Integer.parseInt(st.nextToken());
        int[] pluses = new int[n];
        if (n == 1) {
            pluses[0] = 0;
        } else {
            for (int i = 1; i <= n; i++) {
                pluses[i - 1] = i % 3 == 0 ? 0 : 1;
            }
            if (n > 1 && pluses[n - 1] == 1 && pluses[n - 2] != 1) {
                for (int i = 0; i < n; i++) {
                    pluses[i] = i % 3 == 0 ? 0 : 1;
                }
            }
        }
        if(m == 1) {
            for(int i = 0; i < n; i++) {
                System.out.println(pluses[i]);
            }
            return;
        }
        int[] arr = new int[m];
        for (int i = 1; i <= m; i++) {
            arr[i - 1] = i % 3 == 0 ? 0 : 1;
        }
        if (m > 1 && arr[m - 1] == 1 && arr[m - 2] != 1) {
            for (int i = 0; i < m; i++) {
                arr[i] = i % 3 == 0 ? 0 : 1;
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                System.out.print(arr[j] + pluses[i] + " ");
            }
            System.out.println();
        }
    }
}
