#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define el '\n'
#define ff first
#define ss second
#define pb push_back
#define popb pop_back
#define point pair <ll, ll>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const ll N = 1e6 + 10;
const ll inf = 1e18 + 10;

ll t[3][4 * N], lazy[3][4 * N], pref[3][N], dp[N];
string s;

void push(ll id, ll v) {
    t[id][v << 1] += lazy[id][v];
    t[id][v << 1 | 1] += lazy[id][v];

    lazy[id][v << 1] += lazy[id][v];
    lazy[id][v << 1 | 1] += lazy[id][v];
    lazy[id][v] = 0;
}
void upd(ll id, ll v, ll tl, ll tr, ll l, ll r, ll val) {
    if (l > tr || r < tl)
        return;
    if (l <= tl && r >= tr) {
        t[id][v] += val;
        lazy[id][v] += val;
        return;
    }

    push(id, v);
    ll tm = (tl + tr) >> 1;

    upd(id, v << 1, tl, tm, l, r, val);
    upd(id, v << 1 | 1, tm + 1, tr, l, r, val);

    t[id][v] = max(t[id][v << 1], t[id][v << 1 | 1]);
}
ll get(ll id, ll v, ll tl, ll tr, ll l, ll r) {
    if (l > tr || r < tl)
        return -inf;
    if (l <= tl && r >= tr)
        return t[id][v];

    push(id, v);
    ll tm = (tl + tr) >> 1;

    return max(get(id, v << 1, tl, tm, l, r),
               get(id, v << 1 | 1, tm + 1, tr, l, r));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll tests;
    cin >> tests;

    while (tests--) {
        ll n;
        cin >> n;

        cin >> s;
        s = '#' + s;

        for (ll i = 1; i <= n; i++)
            for (ll j = 0; j < 3; j++)
                pref[j][i] = 0;
        for (ll i = 0; i < n * 4 + 10; i++)
            for (ll j = 0; j < 3; j++)
                t[j][i] = lazy[j][i] = 0;

        for (ll i = 1; i <= n; i++)
            pref[s[i] - 'A'][i]++;
        for (ll i = 1; i <= n; i++)
            for (ll j = 0; j < 3; j++)
                pref[j][i] += pref[j][i - 1];

        for (ll i = 1; i <= n; i++)
            dp[i] = 0;

        ll mx = 0;
        for (ll i = 1; i <= n; i++) {
            upd(s[i] - 'A', 1, 1, n, i, i, dp[i - 1]);
            upd((s[i] - 'A' + 2) % 3, 1, 1, n, 1, i, 1);

            dp[i] = mx;

            ll l = 0, r = i;
            while (l + 1 < r) {
                ll mid = (l + r) >> 1;

                bool ok = 0;
                for (ll j = 0; j < 3; j++)
                    ok |= pref[j][i] - pref[j][mid - 1] == 0;

                if (ok) r = mid;
                else l = mid;
            }

            string cur = "";
            if (pref[0][i] - pref[0][r - 1] != 0)
                cur += 'A';
            if (pref[1][i] - pref[1][r - 1] != 0)
                cur += 'B';
            if (pref[2][i] - pref[2][r - 1] != 0)
                cur += 'C';

            if (cur.size() == 1)
                continue;

            if (cur == "AC")
                swap(cur[0], cur[1]);

            dp[i] = max(dp[i], get(cur[0] - 'A', 1, 1, n, r, i));
            cout << i << " " << dp[i] << ": " << r << " " << i << el;

            if (i == 5)
                cout << get(2, 1, 1, n, 3, 3) << el;
        }

        cout << dp[n] << el;
    }

    return 0;
}
