#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define el '\n'
#define ff first
#define ss second
#define pb push_back
#define popb pop_back
#define point pair <ll, ll>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const ll N = 1e6 + 10;
const ll inf = 1e18 + 10;

ll dp[N];
string s;
ll calc(ll l, ll r) {
    ll cnt[3] = {0, 0, 0};

    for (ll i = l; i <= r; i++)
        cnt[s[i] - 'A']++;

    if (cnt[0] != 0 && cnt[1] != 0 && cnt[2] != 0)
        return 0;

    string cur = "";
    cur += s[l];
    cur += s[r];

    if (cur != "AB" && cur != "BC" && cur != "CA")
        return 0;

    ll now = 0, res = 0;
    for (ll i = r; i >= l; i--) {
        if (s[i] == cur[1]) now++;
        else res += now;
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll tests;
    cin >> tests;

    while (tests--) {
        ll n;
        cin >> n;

        cin >> s;
        s = '#' + s;

        for (ll i = 1; i <= n; i++)
            dp[i] = 0;

        for (ll i = 1; i <= n; i++) {
            dp[i] = dp[i - 1];
            for (ll j = 1; j < i; j++)
                dp[i] = max(dp[i], dp[j - 1] + calc(j, i));
        }

        cout << dp[n] << el;
    }

    return 0;
}
