n, m = map(int, input().split())

def find_solution(m: int, startswith: str, double: str, single: str):
    if m == 1:
        return single
    elif m == 2:
        return double + double
    else:
        result = startswith
        prev = result[-1]
        prev_prev = ""

        for i in range(1, m):
            if prev == single:
                result += double
            elif prev == double and prev_prev in single:
                result += double
            elif prev == double and prev_prev == double:
                result += single
            else:
                raise Exception(prev, prev_prev, result)

            prev_prev = prev
            prev = result[-1]

        return result

def find_solution_n1(m):
    result = find_solution(m, "1", "1", "0")

    if result.endswith("01") or result == "1":
        result = find_solution(m, "0", "1", "0")

    return result.replace("1", " 1").replace("0", " 0")

def find_solution_n2(m):
    result = find_solution(m, "2", "2", "1")

    if result.endswith("12") or result == "2":
        result = find_solution(m, "1", "2", "1")

    result = result.replace("1", " 1").replace("2", " 2")

    return result + "\n" + result

if n == 1:
    print(find_solution_n1(m))
elif n == 2:
    print(find_solution_n2(m))
elif n == 3:
    print(find_solution_n1(m) + "\n" + find_solution_n2(m))
elif n == m == 4:
    print("0 1 1 0\n1 2 2 1\n1 2 2 1\n0 1 1 0")



# 1
# 1

# 2 2
# 2 2

# 2 2 1
# 2 2 1

# 1 2 2 1 
# 1 2 2 1

# 2 2 1 2 2
# 2 2 1 2 2


# 1 
# 1
# 0

# 2 2
# 2 2
# 1 1

# 2 2 1
# 2 2 1
# 1 1 0