#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define len(v) (int) (v.size())

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        in >> v[i];
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        out << v[i] << ' ';
    }
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    sort(all(a));
    int ans = 0;
    for (int i = 0; i < n; i++) {
        ans = max(ans, a[2 * i + 1].first - a[2 * i].first);
    }

    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}