#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define len(v) (int) (v.size())

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        in >> v[i];
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        out << v[i] << ' ';
    }
    return out;
}

void solve() {
    int n;
    cin >> n;
    multiset<pair<int, int>> b;
    for (int i = 0; i < 2 * n; i++) {
        int x, y;
        cin >> x >> y;
        b.insert({x, y});
    }

    int ans = 0;
    while (!b.empty()) {
        pair curr = *b.begin();
        b.erase(b.find(curr));
        auto it = b.lower_bound(make_pair(curr.first, 0ll));
        auto it1 = b.upper_bound(*it);
        if (it->second != curr.second && it1 != b.end() && it1->first == curr.first) {
            it = it1;
        }
        ans = max(ans, it->first - curr.first + abs(it->second - curr.second));
        b.erase(it);
    }

    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}