#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define len(v) (int) (v.size())

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        in >> v[i];
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        out << v[i] << ' ';
    }
    return out;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector ans(vector(n, vector(m, 0ll)));

    int di = 0, dj = 0;
    if (n % 3 == 2) di = 1;
    if (m % 3 == 2) dj = 1;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int x = i + di, y = j + dj;
            if (x % 3 > 0 && y % 3 > 0) ans[i][j] = 2;
            else if (x % 3 == 0 && y % 3 == 0) ans[i][j] = 0;
            else ans[i][j] = 1;

            cout << ans[i][j] << ' ';
        }
        cout << '\n';
    }


}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}