#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define len(v) (int) (v.size())

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        in >> v[i];
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        out << v[i] << ' ';
    }
    return out;
}

template<typename T, typename U>
bool chmin(T& a, U b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

const int INF = 1e18;
void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = s[i] - 'A';
    }

    int ans = 0;
    while (true) {
        bool flag = false;
        for (int i = 0; i + 1 < n; i++) {
            if ((a[i] + 1) % 3 == a[i + 1]) {
                swap(a[i], a[i + 1]);
                flag = true;
                ans++;
            }
        }
        if (!flag) break;
    }

    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}