#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define len(v) (int) (v.size())

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        in >> v[i];
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        out << v[i] << ' ';
    }
    return out;
}

template<typename T, typename U>
bool chmin(T& a, U b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename U>
bool chmax(T& a, U b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

const int INF = 1e18;
void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = s[i] - 'A';
    }

    auto get = [&] (vector<int> a) {
        vector<int> left(n + 1, 0), right(n + 1, 0);
        for (int i = 0; i < n; i++) {
            if (a[i] == 0) left[i + 1] = left[i] + 1;
            if (a[i] == 1) left[i + 1] = left[i];
            if (a[i] == 2) left[i + 1] = 0;
        }
        for (int i = n - 1; i >= 0; i--) {
            if (a[i] == 0) right[i] = 0;
            if (a[i] == 1) right[i] = right[i + 1];
            if (a[i] == 2) right[i] = right[i + 1] + 1;
        }

        int ans = 0;
        for (int i = 0; i < n; i++) {
            if (a[i] == 1) {
                ans += max(right[i], left[i]);
            }
        }

        return ans;
    };

    int ans = get(a);
    for (int i = 0; i < n; i++) {
        a[i] = (a[i] + 1) % 3;
    }
    chmax(ans, get(a));
    for (int i = 0; i < n; i++) {
        a[i] = (a[i] + 1) % 3;
    }
    chmax(ans, get(a));

    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}