#include <bits/stdc++.h>
using namespace std;

bool is_prime(long long n) {
    for (int i = 2; i <= sqrt(n); i++) {
        if (n % i == 0) return false;
    }
    return true;
}

int f(vector <int> v) {
    long long x, sum, ans = 0;
    for (int id = 0; id < (1<<v.size()); id++) {
        x = id;
        sum = 0;
        for (int i = 0; i < v.size(); i++) {
            if (x % 2 == 1) sum += v[i];
            x /= 2;
        }
        if (is_prime(sum)) ans++;
    }
    return ans;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector <int> v(n);
    for (int i = 0; i < n; i++) cin >> v[i];
    sort(v.begin(), v.end());
    cout << f(v) << "\n" << n << " ";
    for (int i = 0; i < n; i++) cout << v[i] << " ";
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) solve();
}
