#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <string>

using namespace std;
using ll = long long;

void handle_test() {
    int n;
    cin >> n;

    string s;
    cin >> s;

    // function<int(string&)> count_ops = [&](string& str) {
    //     int res = 0;

    //     for (int i = 0; i < str.length() - 1; i++) {
    //         if (str[i + 1] - 'A' == (str[i] - 'A' + 1) % 3) {
    //             swap(str[i], str[i + 1]);
    //             res = max(res, count_ops(str) + 1);
    //             swap(str[i], str[i + 1]);
    //         }
    //     }

    //     return res;
    // };

    // cout << count_ops(s) << "\n";

    // int a_count = 0;
    // int b_count = 0;
    // int c_count = 0;

    // for (int i = 0; i < s.length(); i++) {
    //     if (s[i] == 'A') {
    //         a_count += 1;
    //     } else if (s[i] == 'B') {
    //         b_count += 1;
    //     } else if (s[i] == 'C') {
    //         c_count += 1;
    //     }
    // }

    // cout << b_count * max(a_count, c_count) << "\n";

    // auto dp { vector(s.length(), vector<ll>(3, 0)) };
    // dp[0][s[0] - 'A'] = 1;

    // for (int i = 1; i < s.length(); i++) {
    //     int letter = s[i] - 'A';
    //     dp[i][letter] = max({ dp[i - 1][0], dp[i - 1][1], dp[i - 2][2] });
    //     dp[i][(letter + 2) % 3] = dp[i - 1][(letter + 2) % 3] + 1;
    // }

    // cout << max({ dp.back()[0], dp.back()[1], dp.back()[2] }) << "\n";

    // ll res = 0;
    // int b_so_far = 0;

    // for (int i = s.length() - 1; i >= 0; i--) {
    //     if (s[i] == 'B') {
    //         b_so_far += 1;
    //     } else {
    //         res += b_so_far;
    //     }
    // }

    // cout << res << "\n";

    ll res = 0;
    int curr_start = 0;
    int last_a = -1;

    for (int i = 0; i <= s.length(); i++) {
        if (i == s.length() || s[i] == 'C') {
            ll b_count = last_a >= curr_start ? i - last_a - 1 : 0;
            ll c_count = 0;
            ll option2 = 0;

            if (last_a >= curr_start) {
                int b_so_far = 0;

                for (int j = i - 1; j >= curr_start; j--) {
                    if (s[j] == 'B') {
                        b_so_far += 1;
                    } else {
                        option2 += b_so_far;
                    }
                }
            }

            while (i < s.length() && s[i] == 'C') {
                c_count += 1;
                i++;
            }

            if (c_count > 0) {
                i--;
            }

            ll option1 = c_count * b_count;

            if (option1 > option2 && last_a >= curr_start) {
                for (int j = last_a + 1; j < last_a + c_count + 1; j++) {
                    s[j] = 'C';
                }

                for (int j = last_a + c_count + 1; j <= i; j++) {
                    s[j] = 'B';
                }

                curr_start = last_a + c_count + 1;
                res += option1;
            } else {
                curr_start = i + 1;
                res += option2;
            }

            last_a = curr_start - 1;
        } else if (s[i] == 'A') {
            last_a = i;
        }
    }

    cout << res << "\n";
}

int main() {
#ifndef DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int tests;
    cin >> tests;

    while (tests--) {
        handle_test();
    }

    return 0;
}
