#include <iostream>
#include <vector>
#include <queue>
#include <unordered_map>
#include <algorithm>
void solve() {
    int n;
    std::cin >> n;
    std::string s;
    std::cin >> s;
    std::queue<std::pair<std::string, int>> pq;
    pq.push(std::make_pair(s, 0));
    std::unordered_map<std::string, bool> vis;
    int ans = 0;
    while (!pq.empty()) {
        auto p = pq.front();
        pq.pop();
        if (vis[p.first]) continue;
        vis[p.first] = true;
        ans = std::max(ans, p.second);
        for (int i = 1; i < (int)p.first.length(); ++i) {
            if ((p.first[i] == 'B' && p.first[i-1] == 'A') || 
                (p.first[i] == 'C' && p.first[i-1] == 'B') ||
                (p.first[i] == 'A' && p.first[i-1] == 'C')) {
                std::swap(p.first[i], p.first[i-1]);
                pq.push(std::make_pair(p.first, p.second + 1));
                std::swap(p.first[i], p.first[i-1]);
            }
        }
    }
    std::cout << ans << '\n';
}
int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}