#include <iostream>
#include <vector>
#include <algorithm>
#define int long long
#define pii std::pair<int, int>
#define endl '\n'
const int sz = 1e10+1;
bool prime[sz];
signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    int i = 0;
    for (i = 0; i < sz; ++i) {
        prime[i] = true;
    }
    int k = 2;
    for (k = 2; k < sz; ++k) {
        if (!prime[k]) {
            ++k;
            continue;
        }
        for (i = 2; i * k < sz; ++i) {
            prime[i*k] = false;
        }
    }
    for (i = 0; i < 100; ++i) {
        if (prime[i]) {
            std::cout << i << ' ';
        }
        std::cout << endl;
    }
    while (t--) {
        int n, kk;
        std::cin >> n >> kk;
        std::vector<int> a(n);
        int sum = 0;
        for (i = 0; i < n; ++i) {
            std::cin >> a[i];
            sum += a[i];
        }
        std::cout << (prime[sum] ? 1 : 0) << endl;
    }
    return 0;
}