
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

//Andrew Holod will NOT win IOI 2025

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair < ll, ll > pii;
typedef pair < ld, ld > pdd;

const ll DIM = 407;
const ll INF = 1e18;

ll n, m;
ll a[DIM][DIM];

void solveRow(ll row, ll type, ll st) {
    if(type == 1) {
        if(st == 0) {
            a[row][1] = 0;
            a[row][2] = 1;
            a[row][3] = 1;
            for(int i = 4; i <= m; i++) {
                if(a[row][i - 1] == 0) a[row][i] = 1;
                else if(a[row][i - 2] == 1 && a[row][i - 1] == 1) a[row][i] = 0;
                else if(a[row][i - 2] == 0 && a[row][i - 1] == 1) a[row][i] = 1;
            }
        }
        else {
            a[row][1] = 1;
            a[row][2] = 1;
            a[row][3] = 0;
            for(int i = 4; i <= m; i++) {
                if(a[row][i - 1] == 0) a[row][i] = 1;
                else if(a[row][i - 2] == 1 && a[row][i - 1] == 1) a[row][i] = 0;
                else if(a[row][i - 2] == 0 && a[row][i - 1] == 1) a[row][i] = 1;
            }
        }
    }
    else {
        if(st == 0) {
            a[row][1] = 1;
            a[row][2] = 2;
            a[row][3] = 2;
            for(int i = 4; i <= m; i++) {
                if(a[row][i - 1] == 1) a[row][i] = 2;
                else if(a[row][i - 2] == 2 && a[row][i - 1] == 2) a[row][i] = 1;
                else if(a[row][i - 2] == 1 && a[row][i - 1] == 2) a[row][i] = 2;
            }
        }
        else {
            a[row][1] = 2;
            a[row][2] = 2;
            a[row][3] = 1;
            for(int i = 4; i <= m; i++) {
                if(a[row][i - 1] == 1) a[row][i] = 2;
                else if(a[row][i - 2] == 2 && a[row][i - 1] == 2) a[row][i] = 1;
                else if(a[row][i - 2] == 1 && a[row][i - 1] == 2) a[row][i] = 2;
            }
        }
    }
}

int main()
{
    cin >> n >> m;

    if(n % 3 == 2) {
        if(m % 3 == 2) {
            solveRow(1, 2, 1);
            ll last = 1;
            for(int i = 2; i <= n; i++) {
                last++;
                last %= 3;
                if(last == 0) solveRow(i, 1, 1);
                else solveRow(i, 2, 1);
            }
        }
        else {
            solveRow(1, 2, 0);
            ll last = 1;
            for(int i = 2; i <= n; i++) {
                last++;
                last %= 3;
                if(last == 0) solveRow(i, 1, 0);
                else solveRow(i, 2, 0);
            }
        }
    }
    else {
        if(m % 3 == 2) {
            solveRow(1, 1, 1);
            ll last = 0;
            for(int i = 2; i <= n; i++) {
                last++;
                last %= 3;
                if(last == 0) solveRow(i, 1, 1);
                else solveRow(i, 2, 1);
            }
        }
        else {
            solveRow(1, 1, 0);
            ll last = 0;
            for(int i = 2; i <= n; i++) {
                last++;
                last %= 3;
                if(last == 0) solveRow(i, 1, 0);
                else solveRow(i, 2, 0);
            }
        }
    }

    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            cout << a[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
