#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

//Andrew Holod will NOT win IOI 2025

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair < ll, ll > pii;
typedef pair < ld, ld > pdd;

const ll DIM = 600007;
const ll INF = 1e18;

bool used[15][DIM];
ll F[15][DIM];

string toStr(ll val, ll len) {
    string res;
    for(int i = 1; i <= len; i++) {
        if(val % 3 == 0) res += "A";
        if(val % 3 == 1) res += "B";
        if(val % 3 == 2) res += "C";
        val /= 3;
    }
    return res;
}

ll tonum(string s) {
    ll res =0;
    ll val = 1;
    for(int i = 0; i < s.length(); i++) {
        if(s[i] == 'A') res += val * 0;
        if(s[i] == 'B') res += val * 1;
        if(s[i] == 'C') res += val * 2;
        val *= 3;
    }
    return res;
}

void dfs(ll len, ll mask) {
    used[len][mask] = true;
    string s = toStr(mask, len);
    for(int i = 0; i < len - 1; i++) {
        if((s[i] == 'A' && s[i + 1] == 'B') || (s[i] == 'B' && s[i + 1] == 'C') || (s[i] == 'C' && s[i + 1] == 'A')) {
            string to = s;
            swap(to[i], to[i + 1]);

            ll num = tonum(to);
            if(!used[len][num]) dfs(len, num);

            F[len][mask] = max(F[len][mask], F[len][num] + 1);
        }
    }
}

int main()
{
    for(int i = 1; i <= 12; i++) {
        for(int mask = 0; mask < DIM; mask++) {
            if(!used[i][mask]) dfs(i, mask);
        }
    }

    ll T;
    cin >> T;
    while(T--) {
        ll len;
        string s;
        cin >> len;
        cin >> s;
        cout << F[len][tonum(s)] << endl;
    }
    return 0;
}
