#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

//Andrew Holod will NOT win IOI 2025

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair < ll, ll > pii;
typedef pair < ld, ld > pdd;

const ll DIM = 27;
const ll MXNUM = 2e6;
const ll MXMASK = (1 << 10);
const ll INF = 1e18;

ll n, k;
ll a[DIM], sum[MXMASK];

pii F[DIM][MXMASK];

bool isprime[MXNUM];

vector < ll > into[MXMASK];

int main()
{
    for(int i = 2; i < MXNUM; i++) isprime[i] = true;

    for(int i = 2; i < MXNUM; i++) {
        if(isprime[i]) {
            ll j = 2 * i;
            while(j < MXNUM) {
                isprime[j] = false;
                j += i;
            }
        }
    }

    for(int i = 0; i < MXMASK; i++) {
        for(int j = 0; j < MXMASK; j++) {
            ll m1 = i, m2 = j;
            bool flag = true;
            while(m1 > 0 || m2 > 0) {
                if((m2 & 1) && !(m1 & 1)) flag = false;
                m1 >>= 1;
                m2 >>= 1;
            }

            if(flag) into[i].push_back(j);
        }
    }

    ll T;
    cin >> T;
    while(T--) {
        cin >> n >> k;
        for(int i = 1; i <= n; i++) cin >> a[i];

        if(k != 1) {
            for(int mask = 0; mask < MXMASK; mask++) sum[mask] = 0;
            for(int mask = 0; mask < MXMASK; mask++) {
                ll m = mask, bitnum = 1;
                while(m > 0) {
                    if(m & 1) {
                        sum[mask] += a[bitnum];
                    }
                    bitnum++;
                    m >>= 1;
                }
            }

            for(int i = 0; i <= k; i++) {
                for(int mask = 0; mask < MXMASK; mask++) {
                    F[i][mask] = { INF, - 1};
                }
            }

            for(int mask = 1; mask < MXMASK; mask++) F[1][mask] = { isprime[sum[mask]], mask };
            for(int j = 2; j <= k; j++) {
                for(int mask = 0; mask < MXMASK; mask++) {
                    for(auto x: into[mask]) {
                        if(x != 0) {
                            if(F[j][mask].first > F[j - 1][mask xor x].first + isprime[sum[x]]) {
                                F[j][mask] = {F[j - 1][mask xor x].first + isprime[sum[x]], x};
                            }
                        }
                    }
                }
            }
            cout << F[k][(1 << n) - 1].first << endl;

            ll currc = k, currmask = (1 << n) - 1;
            while(currc > 0) {
                ll m = F[currc][currmask].second;
                ll bitnum = 1;
                vector < ll > tmp;
                while(m > 0) {
                    if(m & 1) {
                        tmp.push_back(a[bitnum]);
                    }
                    bitnum++;
                    m >>= 1;
                }
                cout << tmp.size();
                for(auto x: tmp) cout << " " << x;
                cout << endl;
                currmask = (currmask xor F[currc][currmask].second);
                currc--;
            }
        }
        else {
            ll s = 0;
            for(int i = 1; i <= n; i++) s += a[i];

            cout << isprime[s] << endl;
            cout << n << " ";
            for(int i = 1; i<= n; i++) cout << a[i] << " ";
            cout << endl;
        }
    }
    return 0;
}
