#include <iostream>
#include <vector>
#include <utility>
#include <unordered_map>
#include <algorithm>
#include <cmath>
using namespace std;
typedef long long ll;

int n;

bool comp(pair<ll, ll> a, pair<ll, ll> b){
    if(a.first==b.first){
        return a.second < b.second;
    }
    else return a.first < b.first;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    vector<pair<ll, ll>> a(2 * n);
    for (int i = 0; i < 2 * n; i++){
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end(), comp);

    ll ans = 0;

    for (int i = 0; i < 2 * n; i += 2){
        ll temp = fabs(a[i].first - a[i + 1].first) + fabs(a[i].second - a[i + 1].second);
        ans = max(ans, temp);
    }

    cout << ans;
}