#include <iostream>
#include <vector>
#include <utility>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <limits.h>
using namespace std;
typedef long long ll;

int n;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    vector<ll> a;
    vector<ll> b;
    for (int i = 0; i < 2 * n; i++){
        ll x, y;
        cin >> x >> y;
        if(y == 0){
            a.push_back(x);
        }
        else b.push_back(x);
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());

    int size_a, size_b;

    if(!a.empty()) size_a = a.size();
    else size_a = 0;

    if (!b.empty()) size_b = b.size();
    else size_b = 0;

    ll ans = 0;
    int ptr1 = 0, ptr2 = 0;
    for (int i = 0; i < 2 * n; i += 2){
        ll l1 = LLONG_MAX, l2 = LLONG_MAX, l3 = LLONG_MAX;
        if (ptr1 < size_a - 1){
            l1 = a[ptr1 + 1] - a[ptr1];
        }
        if (ptr2 < size_b - 1){
            l2 = b[ptr2 + 1] - b[ptr2];
        }
        if (ptr1 < size_a && ptr2 < size_b){
            l3 = fabs(a[ptr1] - b[ptr2]) + 1;
        }

        if(l1 <= l2 && l1 <= l3){
            ans = max(ans, l1);
            ptr1 += 2;
        }
        if(l2 < l1 && l2 < l3){
            ans = max(ans, l2);
            ptr2 += 2;
        }
        if(l3 < l1 && l3 < l2){
            ans = max(ans, l3);
            ptr1++;
            ptr2++;
        }
    }
    cout << ans;
}