#include <bits/stdc++.h>
using namespace std;

bool check(vector<vector<char>>& mat) {
    if (mat.empty()) {
        return true;
    }
    int n = mat.size();
    int m = mat[0].size();
    if (m == 0) {
        return true;
    }
    vector<int> dx = {-1, 0, 1, 0};
    vector<int> dy = {0, -1, 0, 1};
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int cnt = 0;
            for (int d = 0; d < 4; d++) {
                int nx = i + dx[d];
                int ny = j + dy[d];
                if (nx >= 0 && nx < n && ny >= 0 && ny < m && mat[nx][ny] == mat[i][j]) {
                    cnt++;
                }
            }
            if ((cnt + '0') != mat[i][j]) {
                return false;
            }
        }
    }
    return true;
}

// GOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOL

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin>>n>>m;
    if (m == 1) {
        cout << 1 << endl;
        cout << 1 << endl;
        cout << 0 << endl;
        return 0;
    }
    if (m == 2) {
        cout << "2 2" << endl;
        cout << "2 2" << endl;
        cout << "1 1" << endl;
        return 0;
    }
    vector<vector<char>> mat1(1, vector<char>(m - 2)), mat2(1, vector<char>(m - 2));
    for (int i = 0; i < m - 2; i++) {
        mat1[0][i] = (i % 3 == 0) ? '0' : '1';
        mat2[0][i] = (i % 3 == 2) ? '0' : '1';
    }
    for (int i = 0; i < m; i++) {
        cout << "2 ";
    }
    cout << endl;
    if (check(mat1)) {
        cout << "2 ";
        for (auto& el : mat1[0]) {
            cout << el << " ";
        }
        cout << 2 << endl;
    }
    else {
        cout << "2 ";
        for (auto& el : mat2[0]) {
            cout << el << " ";
        }
        cout << 2 << endl;
    }
    for (int i = 0; i < m; i++) {
        cout << "2 ";
    }
    cout << endl;
}
