#include <bits/stdc++.h>
using namespace std;

bool check(vector<vector<char>>& mat) {
    if (mat.empty()) {
        return true;
    }
    int n = mat.size();
    int m = mat[0].size();
    if (m == 0) {
        return true;
    }
    vector<int> dx = {-1, 0, 1, 0};
    vector<int> dy = {0, -1, 0, 1};
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int cnt = 0;
            for (int d = 0; d < 4; d++) {
                int nx = i + dx[d];
                int ny = j + dy[d];
                if (nx >= 0 && nx < n && ny >= 0 && ny < m && mat[nx][ny] == mat[i][j]) {
                    cnt++;
                }
            }
            if ((cnt + '0') != mat[i][j]) {
                cout << i << " " << j << endl;
                return false;
            }
        }
    }
    return true;
}

string gen(int m) {
    string s1 = "";
    string s2 = "";
    for (int i = 0; i < m; i++) {
        s1 += "011";
        s2 += "110";
    }
    bool one = true;
    bool sec = true;
    for (int i = 0; i < m; i++) {
        if (s1[i] == '1') {
            if ((i == 0 || s1[i - 1] == '0') && (i == m - 1 || s1[i + 1] == '0')) {
                one = false;
                break;
            }
        }
        else {
            if ((i > 0 && s1[i - 1] == '0') || (i == m - 1 && s1[i + 1] == '0')) {
                one = false;
                break;
            }
        }     
    }
    for (int i = 0; i < m; i++) {
        if (s2[i] == '1') {
            if ((i == 0 || s2[i - 1] == '0') && (i == m - 1 || s2[i + 1] == '0')) {
                sec = false;
                break;
            }
        }
        else {
            if ((i > 0 && s2[i - 1] == '0') || (i == m - 1 && s2[i + 1] == '0')) {
                sec = false;
                break;
            }
        }     
    }
    if (one) {
        return s1;
    }
    else {
        return s2;
    }
}

int main() {
    // freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin>>n>>m;
    swap(n, m);
    string subaru_big = gen(m);
    string subaru_smal = gen(m - 2);
    vector<vector<char>> mat1(n, vector<char>(m, '2')), mat2(n, vector<char>(m, '2'));
    for (int i = 0; i < n;i++) {
        if (i % 4 == 1) {
            for (int j = 0; j < m - 2; j++) {
                mat1[i][j + 1] = subaru_smal[j];
            }
        }
        if (i % 4 == 3) {
            for (int j = 0; j < m; j++) {
                mat1[i][j] = subaru_big[j];
            }
        }
    }
    // if (check(mat1)) {
        for (int j = 0; j < m; j++) {
            for (int i = 0; i < n; i++) {
                cout << mat1[i][j] << " ";
            }
            cout << endl;
        }
        return 0;
        for (auto& arr : mat1) {
            for (auto& el : arr) {
                cout << el << " ";
            }
            cout << endl;
        }
    // }
    // else {
    //     for (auto& arr : mat2) {
    //         for (auto& el : arr) {
    //             cout << el << " ";
    //         }
    //         cout << endl;
    //     }
    // }
}