#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

ll mod = 1e9 + 7;

ll pow_mod(ll a, ll b, ll mod) {
    ll curr = a;
    ll res = 1;
    while (b) {
        if (b & 1) {
            res *= curr;
            res %= mod;
        }
        curr *= curr;
        b >>= 1;
        curr %= mod;
    }
    return res;
}

int N = 1e5 + 5;
vector<bool> is_prime(N, true);

// Italian brainrot ranked (by Roman Sadovnikov)

// 1). Bombardiro Crocodilo
// 2). Lirrili Larrili (idk if it's correct)
// 3). Trippi Troppa
// 4). Trallalero trallala
// 5). Bum bum bini gussini

// Thanks for watching

void solve() {
    int n, k;
    cin>>n>>k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin>>a[i];
    }
    sort(a.begin(), a.end());
    int res = 1e9;
    vector<vector<int>> ans;
    while (true) {
        for (int msk = 0; msk < (1 << n); msk++) {
            if (msk & 1) {
                continue;
            }
            vector<vector<int>> cinds;
            int cm = msk;
            vector<int> cr;
            for (int i = 0; i < n; i++) {
                if (cm & 1) {
                    cinds.push_back(cr);
                    cr.clear();
                }
                cr.push_back(a[i]);
                cm >>= 1;
            }
            cinds.push_back(cr);
            if (cinds.size() != k) {
                continue;
            }
            int cnt = 0;
            for (auto& arr : cinds) {
                int sm = 0;
                for (auto& el : arr) {
                    sm += el;
                }
                if (is_prime[sm]) {
                    cnt++;
                }
            }
            if (cnt < res) {
                res = cnt;
                ans = cinds;
            }
        }
        if (!next_permutation(a.begin(), a.end())) {
            break;
        }
    }
    cout << res << endl;
    for (auto& arr : ans) {
        if (arr.empty()) {
            continue;
        }
        cout << arr.size() << " ";
        for (auto& el : arr) {
            cout << el << " ";
        }
        cout << endl;
    }
}


int main() {
    // freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    for (ll i = 2; i < N; i++) {
        if (!is_prime[i]) {
            continue;
        }
        for (ll j = i * i; j < N; j += i) {
            is_prime[j] = false;
        }
    }

    int t;
    cin>>t;
    while (t) {
        solve();
        t--;
    }
}