#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> m >> n;
    vector a(m, string('2', n));
	vector<array<int,2>> de(210);
	for (auto &i : de)
		for (auto &j :i)
			j = -1;
	de[1][0] = 1;
	de[2][1] = 2;
	for (int i=0; i < 200; i ++) {
		if (de[i][0] != -1) {
			de[i + 2][1] = 2;
		}
		if (de[i][1] != -1)
			de[i + 1][0] = 1;
	}
    auto draw_vline = [&](int x, int y, int w) {
		int d = w;
		int t = de[d][0] == -1 ? 1 : 0;
		while (d) {
            /*a[x + i][y] = '|';*/
			if (t == 0) a[x + d - 1][y] = '0';
			else a[x + d - 1][y] = a[x + d - 2][y] = '1';
			d -= de[d][t];
			t ^= 1;
        }
    };
    auto draw_dline = [&](int x, int y, int w) {
        draw_vline(x,y,w);
        for (int i = 0; i < w; i ++) {
			if (a[x + i][y] == '1') {
				a[x + i][y] = '2';
				a[x + i][y + 1] = '2';
			} else {
                a[x + i][y] = '1';
                a[x + i][y+1] = '1';
            }
        }
    };
    auto draw_box = [&](int x, int y, int w) {
        for (int i = 0; i < w; i ++) {
            a[x + i][y] = '2';
            a[x + i][y + 1] = '2';
            a[x + i][y + 2] = '2';
        }
        draw_vline(x + 1, y + 1, w - 2);
    };
    function<bool(int,int)> scan = [&](int p, int o) {
        if (p == n) return true;
        if (p > n) return false;
        for (int i = 1; i < 4; i ++) {
            if (i == o ||
            (min(i, o) == 1 && max(i, o) == 2) || 
            (min(i, o) == 2 && max(i, o) == 3)) continue;
            if (scan(p + i, i)) {
                //cout << p << " " << i << endl;
                if (i == 1) draw_vline(0, p, m);
                else if (i == 2) draw_dline(0, p, m);
                else if (i == 3) draw_box(0, p, m);
                return true;
            }
        }
        return false;
    };
    scan(0,-1);
    for (auto &i : a)  {
        for (auto j : i)
             cout << j << ' ';
        cout << '\n';
    }
}

