#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

bool prime(ll n){
    if(n == 1)
        return false;

    for(int i = 2; i * i <= n; i++)
        if(n % i == 0)
            return false;

    return true;
}

pair<vector<ll>, vector<ll>> get(ll n, vector<ll> a){
    vector<ll> other, own;

    for(int i = 0; i < (1ll << n); i++){
        ll cnt = 0, s = 0;

        for(int j = 0; j < n; j++){
            if((i >> j) & 1)
                cnt++, s += a[j];
        }

        if(cnt == 3 && !prime(s)){
            for(int j = 0; j < n; j++){
                if((i >> j) & 1)
                    other.push_back(a[j]);
                else
                    own.push_back(a[j]);
            }

            break;
        }
    }

    return {other, own};
}

int main(){
    ll t;
    cin >> t;

    while(t--){
        ll n, k;
        cin >> n >> k;

        vector<ll> a(n);
        for(auto &i: a)
            cin >> i;

        if(n == 1){
            cout << 1 << endl << 1 << ' ' << a[0] << endl;
            continue;
        }
        if(n == 2){
            if(k == 1){
                cout << prime(a[0] + a[1]) << endl << 2 << ' ' << a[0] << ' ' << a[1] << endl;
            }
            else{
                cout << 2 << endl << 1 << ' ' << a[0] << endl << 1 << ' ' << a[1] << endl;
            }

            continue;
        }

        if(n == 3){
            if(k == 1){
                cout << prime(a[0] + a[1] + a[2]) << endl << 1 << ' ' << a[0] << ' ' << a[1] << ' ' << a[2] << endl;
            }
            else if(k == 2){
                cout << 1 << endl << 2 << ' ' << a[0] << ' ' << a[1] << endl << 1 << ' ' << a[2] << endl;
            }
            else if(k == 3){
                cout << 3 << endl << 1 << ' ' << a[0] << endl << 1 << ' ' << a[1] << endl << 1 << ' ' << a[2] << endl;
            }

            continue;
        }

        if(n % 2 == 0){
            ll can = n - k;

            cout << k - can << endl;

            for(int i = 0; i < n; i++){
                if(can == 0){
                    cout << 1 << ' ' << a[i] << endl;
                    continue;
                }
                can--;
                cout << 2 << ' ' << a[i] << ' ' << a[i + 1] << endl;
                i++;
            }

            continue;
        }

        if(k == 1){
            ll s = 0;
            for(auto i: a)
                s += i;

            cout << prime(s) << endl;

            cout << n << ' ';
            for(auto i: a)
                cout << i << ' ';
            cout << endl;

            continue;
        }

        vector<ll> c(3);

        for(auto i: a)
            c[i % 3]++;

        vector<ll> triple, other;

        for(int i = 0; i < 3; i++){
            if(c[i] >= 3){
                ll cur = 0;

                for(int j = 0; j < n; j++){
                    if(a[j] % 3 == i && cur < 3){
                        cur++;
                        triple.push_back(a[j]);
                    }
                    else
                        other.push_back(a[j]);
                }

                break;
            }
        }

        if(triple.empty()){
            auto v = get(n, a);

            triple = v.first, other = v.second;
        }

        ll can = (n - 3) / 2;

        if(can + 1 >= k){
            cout << 0 << endl;

            cout << 3 << ' ';
            for(auto i: triple)
                cout << i << ' ';
            cout << endl;

            k--;

            for(int i = 0; i < other.size(); i += 2){
                if(k == 1){
                    cout << (ll)(other.size()) - i << ' ';

                    for(int j = i; j < other.size(); j++)
                        cout << other[j] << ' ';
                    cout << endl;
                    break;
                }

                k--;
                cout << 2 << ' ' << other[i] << ' ' << other[i + 1] << endl;
            }
        }
        else{
            ll need = k - (can + 1);

            for(auto i: triple)
                other.push_back(i);

            ll can = n - k;

            cout << k - can << endl;

            for(int i = 0; i < n; i++){
                if(can == 0){
                    cout << 1 << ' ' << a[i] << endl;
                    continue;
                }

                cout << 2 << ' ' << a[i] << ' ' << a[i + 1] << endl;
                can--;
                i++;
            }
        }
    }

    return 0;
}
/*
1
7 3
3 5 7 7 11 13 19

*/
