//in honor of VIKA G
//powered by Andriy Popyk

#include <bits/stdc++.h>

using namespace std;
typedef long long lli;
#define LF '\n'

const lli N = 3e5;
bool p[N+1];

bool check(lli a){
    if (a<N)return !p[a];
    for (int i =2;i<=sqrt(a);i++){
        if (a%i==0)return 0;
    }
    return 1;
}

vector<lli> v;

void func0(lli n){
    lli s= 0;
    for (int i =1;i<=n;i++)s+=v[i];
    if (check(s))cout << 1;
    else cout << 0;
    cout << LF;
    cout << n << " ";
    for (int i =1;i<=n;i++)cout << v[i] << " ";
    cout << LF;
}

struct SIGMAK_DSU
{
    vector<lli> boss;
    vector<vector<lli>> arr;
    vector<lli> s;
    lli f1,f2;
    void init(lli n){
        boss.clear();
        boss.resize(n+1);
        arr.clear();
        arr.resize(n+1);
        s.clear();
        s.resize(n+1);
        for (int i =1;i<=n;i++){
            boss[i]=i;
            arr[i].push_back(v[i]);
            s[i]=v[i];
        }
        f1=1;
        f2=2;
    }

    lli get(lli a){
        if (boss[a]==a)return a;
        return boss[a] = get(boss[a]);
    }


    void merge(lli u1,lli u2){
        lli b1 = get(u1);
        lli b2 = get(u2);
        if (arr[b1].size()<arr[b2].size())swap(b1,b2);
        boss[b2]=b1;
        s[b1]+=s[b2];
        for (auto to : arr[b2])arr[b1].push_back(to);
    }

    void super_merge(){
        while(boss[f1]!=f1 || s[f1]%2==1)f1++;
        while(f2<=f1 || boss[f2]!=f2 || s[f2]%2==1)f2++;
        merge(f1,f2);
    }

    void print(lli n){
        lli cnt = 0;
        for (int i =1;i<=n;i++)if (boss[i]==i && check(s[i]))cnt++;
        cout << cnt << LF;
        for (int i =1;i<=n;i++){
            if (boss[i]==i){
                cout << arr[i].size() << " ";
                for (auto to : arr[i])cout << to << " ";
                cout << LF;
            }
        }
    }
}dsu;

void func20(lli n,lli k)
{
    for (int i = 1;i<=n;i+=2){
        if (!k)break;
        dsu.merge(i,i+1);
        k--;
    }
    while(k){
        dsu.super_merge();
        k--;
    }
    dsu.print(n);
    cout << LF;
    return;
}

void make(lli v1,lli v2,lli v3,lli n,lli k){
    vector<lli> used;
    used.resize(n+1);
    lli ind1,ind2,ind3;
    for (int i =1;i<=n;i++){
        if (used[i]==0 && v[i]==v1){
            used[i]=1;
            v1=0;
            ind1=i;
        }
    }
    for (int i =1;i<=n;i++){
        if (used[i]==0 && v[i]==v2){
            used[i]=1;
            v2=0;
            ind2=i;
        }
    }
    for (int i =1;i<=n;i++){
        if (used[i]==0 && v[i]==v3){
            used[i]=1;
            v3=0;
            ind3=i;
        }
    }

    dsu.merge(ind1,ind2);
    dsu.merge(ind1,ind3);
    k-=2;
    for (int i =n;i>=2;i--){
        if (!k)break;
        if (used[i])continue;
        for (int j =i-1;j>=1;j--){
            if (used[j]==0){
                dsu.merge(i,j);
                used[j]=1;
                k--;
                break;
            }
        }
    }
    for (int i =2;i<=n;i++)if (i!=ind1 && i!=ind2 && i!=ind3){dsu.merge(1,i);k--;break;}
    while(k){
        dsu.super_merge();
        k--;
    }
    dsu.print(n);
}

void func21(lli n,lli k)
{
    lli g=0;
    for (int i =1;i<=n;i++){
        if (v[i]!=2 && !check(v[i]+2)){
            g=i;
            break;
        }
    }
    if (g!=0){
        for (int i =n;i>=2;i-=2){
            if (k==0)break;
            if (i==g)i--;
            if (i!=1){
                if (g==i-1){
                    if (i!=2){
                        dsu.merge(i-2,i);
                        k--;
                        i--;
                    }
                }else{
                    dsu.merge(i,i-1);
                    k--;
                   // dsu.print(n);
                   // cout << LF;
                }
            }
        }
        if (k){
            dsu.merge(1,g);
            k--;
        }
      //  dsu.print(n);
     //   cout << LF;
        while(k){
            dsu.super_merge();
            k--;
        }
        dsu.print(n);
        return;
    }
    if (k<=n/2){
        func20(n,k);
        return;
    }
    map<lli,lli> mp;
    vector<lli> c;
    for (int i =1;i<=n;i++){
        if (v[i]!=2)mp[v[i]]++;
    }
    for (auto to : mp)for (int i =1;i<=min(3LL,to.second);i++)c.push_back(to.first);
    for (int i =0;i<c.size();i++){
        for (int j=i+1;j<c.size();j++){
            for (int z =j+1;z<c.size();z++){
                if (!check(c[i]+c[j]+c[z])){
                    make(c[i],c[j],c[z],n,k);
                    return;
                }
            }
        }
    }
}

void solve()
{
    lli n,k;
    cin >> n >> k;
    v.clear();
    v.resize(n+1);
    for (int i =1;i<=n;i++)cin >> v[i];
    if (k==1){
        func0(n);
        return;
    }
    k=n-k;
    sort(v.begin()+1,v.end());
    dsu.init(n);
    lli cnt2 = 0;
    for (int i =1;i<=n;i++)if (v[i]==2)cnt2++;
    if (n%2==0){
        if (cnt2%2==0){
            func20(n,k);
        }else{
            func21(n,k);
        }
    }

}

int main()
{
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);

    for (int i =2;i<=N;i++){
        for (int j =2;j*i<=N;j++)p[i*j]=1;
    }

    lli t;
    cin >> t;
    while(t--)solve();
}