#include <iostream>
#include <vector>
#include <algorithm>>
using namespace std;



int main() {
    int n;
    cin >> n;

    vector<pair<int,int>> points(2*n);
    for (int i = 0; i < 2*n; i++) {
        cin >> points[i].first >> points[i].second;
    }

    sort(points.begin(), points.end(), [](pair<int,int> a, pair<int,int> b) {
        return a.second < b.second;
    });
    int m = -1;
    for (int i = 0; i < 2*n; i+=2) {
        int dist = abs(points[i].first - points[i+1].first) + abs(points[i].second - points[i+1].second);
        m = max(m, dist);
    }

    cout<<m<<endl;


    return 0;
}