#include <iostream>
#include <vector>
#include <algorithm>>
#include <map>
using namespace std;



int main() {
    int n;
    cin >> n;

    vector<int> points(2*n);
    map<int,vector<pair<int,int>>> map;
    for (int i = 0; i < 2*n; i++) {
        int x,y;
        cin >> x >> y;
        points[i] = x;
        map[x].push_back({x, y});
    }

    sort(points.begin(), points.end());

    int m = -1;
    vector<pair<int,int>> wait;
    for (int& x : points) {
        vector<pair<int,int>> one_coord = map[x];
        int one_count = 0;
        int zero_count = 0;
        
        for (auto& y : one_coord) {
            if (y.second == 1) {
                one_count++;
            }
            else {
                zero_count++;
            }
        }
        
        if (wait.size() > 0 && one_coord.size() > 0) {
            if (wait[0].second == 0) {
                if (zero_count != 0) {
                    int dist = abs(wait[0].first - x);
                    m = max(dist, m);
                    zero_count--;
                }
                else {
                    int dist = abs(wait[0].first - x) + 1;
                    m = max(dist, m);
                    one_count--;
                }
            }
            else {
                if (one_count != 0) {
                    int dist = abs(wait[0].first - x);
                    m = max(dist, m);
                    one_count--;
                }
                else {
                    int dist = abs(wait[0].first - x) + 1;
                    m = max(dist, m);
                    zero_count--;
                }
            }
            wait.pop_back();
        }


        zero_count %= 2;
        one_count %= 2;
        if (zero_count != 0) {
            wait.push_back({x,0});
        }
        if (one_count != 0) {
            wait.push_back({x,1});
        }
    }

    cout<<m<<endl;


    return 0;
}