#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_set>
using namespace std;

int HelpPrevious(vector<int>& p, pair<int,int>& wait, int i, map<int,pair<int,int>>& map, int& zero_count, int& one_count) {
    int m = 0;


    if (wait.first != -1 && one_count+zero_count != 0) {
        if (wait.second == 0) {
            if (zero_count != 0) {
                int dist = abs(wait.first - p[i]);
                m = max(dist, m);
                zero_count--;
            }
            else {
                int dist = abs(wait.first - p[i]) + 1;
                m = max(dist, m);
                one_count--;
            }
        }
        else {
            if (one_count != 0) {
                int dist = abs(wait.first - p[i]);
                m = max(dist, m);
                one_count--;
            }
            else {
                int dist = abs(wait.first - p[i]) + 1;
                m = max(dist, m);
                zero_count--;
            }
        }
        wait = {-1,-1};
    }

    return m;
}


int HelpNext(vector<int>& p, pair<int,int>& wait, int i, map<int,pair<int,int>>& map, int& zero_count, int& one_count) {
    int m = 0;
    int size = p.size();


    if (i<size-1 && one_count+zero_count!=0) {
        int index = i+1;

        int zero_count1 = map[p[index]].first;
        int one_count1 = map[p[index]].second;

        if (abs(one_count1 - zero_count1) % 2 == 1) {
            // cout<<zero_count<<" "<<one_count<<endl;
            // cout<<zero_count1<<" "<<one_count1<<endl;
            if (zero_count1 % 2 == 1) {
                if (zero_count != 0) {
                    int dist = abs(p[index] - p[i]);
                    zero_count--;
                    map[p[index]].first--;
                    m = max(dist, m);
                }
                else {
                    int dist = abs(p[index] - p[i]) + 1;
                    one_count--;
                    map[p[index]].second--;
                    m = max(dist, m);
                }
            }
            else {
                if (one_count != 0) {
                    int dist = abs(p[index] - p[i]);
                    one_count--;
                    map[p[index]].second--;
                    m = max(dist, m);
                }
                else {
                    int dist = abs(p[index] - p[i]) + 1;
                    zero_count--;
                    map[p[index]].first--;
                    m = max(dist, m);
                }
            }
        }


    }
    return m;
}

int main() {
    int n;
    cin >> n;

    unordered_set<int> points;
    map<int,pair<int,int>> map;
    for (int i = 0; i < 2*n; i++) {
        int x,y;
        cin >> x >> y;
        points.insert(x);
        if (y == 1) {
            map[x].second++;
        }
        if (y==0) {
            map[x].first++;
        }
    }

    // sort(points.begin(), points.end());
    vector<int> p(points.begin(), points.end());
    sort(p.begin(), p.end());

    int m = 0;
    pair<int,int> wait = {-1,-1};
    int s = p.size();
    int count = 0;

    // for (auto [x,y] : map) {
    //     cout<<y.first<<" "<<y.second<<endl;
    // }



    for (int i = 0; i < s; i++) {
        int zero_count = map[p[i]].first;
        int one_count = map[p[i]].second;

        // cout<<zero_count<<" "<<one_count<<endl;



        m = max(m, HelpPrevious(p,wait,i,map,zero_count,one_count));


        m = max(m, HelpNext(p,wait,i,map,zero_count,one_count));




        zero_count %= 2;
        one_count %= 2;


        if (zero_count == 1 && one_count == 1) {
            m = max(m, 1);
        }
        else if (zero_count == 1 && one_count == 0) {
            wait = {p[i], 0};
        }
        else if (one_count == 1 && zero_count == 0) {
            wait = {p[i], 1};
        }


    }

    cout<<m<<endl;


    return 0;
}