#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <math.h>
#include <set>
using namespace std;

bool Prime(int n) {
    if (n <= 1 || n == 2) 
        return true;
    if (n%2 == 0 || n%3 == 0) {
        return false;
    }

    for (int i = 5; i <= sqrt(n); i+=2) {
        if (n%i == 0)
            return false;
    }
    return true;
}

int main() {
    int t;
    cin>>t;

    for (int i = 0; i<t; i++) {
        int n, k;
        cin>>n>>k;
        int sum = 0;
        vector<int> v(n);
        for (int j = 0; j<n; j++) {
            cin>>v[j];
            sum += v[j];
        }

        if (Prime(sum)) {
            cout<<1<<endl;
        }
        else {
            cout<<0<<endl;
        }

        cout<<n<<' ';
        for (int j = 0; j<n; j++) {
            cout<<v[j]<<' ';
        }
        cout<<endl;
    }


    return 0;
}