#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
const ll SIZ = ((ll)2e5+5), LONGBOI = ((ll)1e15+5);
mt19937_64 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

ll n, ans, x0size, x1size, x0pos, x1pos, xnow, dpcnt, lastx;
ll x0[SIZ], x1[SIZ];
ll s0, s1;
queue<pll> q;
ll dp[SIZ][5];

ll getDist(pll pos1, pll pos2){
    return (abs(pos1.first-pos2.first) + abs(pos1.second-pos2.second));
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    ans = 0;

    ll xread, yread;
    for(int i=1; i <= 2*n; i++){
        cin >> xread >> yread;
        if(yread == 0){
            x0size++;
            x0[x0size] = xread;
        }
        else{
            x1size++;
            x1[x1size] = xread;
        }
    }

    sort(x0+1,x0+1+x0size);
    sort(x1+1,x1+1+x1size);

    x0[x0size+1] = LONGBOI;
    x1[x1size+1] = LONGBOI;
    x0pos = 1; x1pos = 1;
    ll d0, d1;
    pll add, v;

    dp[0][0] = LONGBOI;
    dp[0][1] = LONGBOI;
    xnow =-LONGBOI;
    ll update;

    while(x0pos <= x0size || x1pos <= x1size){
        lastx = xnow;
        xnow = min(x0[x0pos], x1[x1pos]);
        s0 = 0; s1 = 0;
        dpcnt++; dp[dpcnt][0] = LONGBOI; dp[dpcnt][1] = LONGBOI; dp[dpcnt][2] = LONGBOI;

        while(x0pos <= x0size && x0[x0pos] == xnow) { s0++; x0pos++; }
        while(x1pos <= x1size && x1[x1pos] == xnow) { s1++; x1pos++; }


        // dp
        if(dp[dpcnt-1][2] != LONGBOI){
            if((s0+s1) % 2 == 0){
                if(s0 % 2 == 0) dp[dpcnt][2] = min(dp[dpcnt][2], dp[dpcnt-1][2]);
                else dp[dpcnt][2] = min(dp[dpcnt][2], max((ll)1, dp[dpcnt-1][2]));
            }
            else{
                if(s0 % 2 == 1) dp[dpcnt][0] = min(dp[dpcnt][0], dp[dpcnt-1][2]);
                else if(s0 == 0) dp[dpcnt][0] = LONGBOI;
                else dp[dpcnt][0] = min(dp[dpcnt][0], max((ll)1, dp[dpcnt-1][2]));

                if(s1 % 2 == 1) dp[dpcnt][1] = min(dp[dpcnt][1], dp[dpcnt-1][2]);
                else if(s1 == 0) dp[dpcnt][1] = LONGBOI;
                else dp[dpcnt][1] = min(dp[dpcnt][1], max((ll)1, dp[dpcnt-1][2]));
            }
        }
        if(dp[dpcnt-1][0] != LONGBOI){
            if((s0+s1) % 2 == 0){
                if(s0 == 0) dp[dpcnt][0] = LONGBOI;
                else{
                    update = LONGBOI;
                    if(s0 > 1) update = min(update, max(dp[dpcnt-1][0], getDist({lastx, 0}, {xnow, 0})));
                    if(s1 > 0) update = min(update, max(dp[dpcnt-1][0], getDist({lastx, 0}, {xnow, 1})));
                    dp[dpcnt][0] = min(dp[dpcnt][0], update);
                }

                if(s1 == 0) dp[dpcnt][1] = LONGBOI;
                else{
                    update = LONGBOI;
                    if(s0 > 0) update = min(update, max(dp[dpcnt-1][0], getDist({lastx, 0}, {xnow, 0})));
                    if(s1 > 1) update = min(update, max(dp[dpcnt-1][0], getDist({lastx, 0}, {xnow, 1})));
                    dp[dpcnt][1] = min(dp[dpcnt][1], update);
                }
            }
            else{
                update = LONGBOI;
                if(s0 > 0) update = min(update, max(dp[dpcnt-1][0], getDist({lastx, 0}, {xnow, 0})));
                if(s1 > 0) update = min(update, max(dp[dpcnt-1][0], getDist({lastx, 0}, {xnow, 1})));
                dp[dpcnt][2] = min(dp[dpcnt][2], update);
            }
        }
        if(dp[dpcnt-1][1] != LONGBOI){
            if((s0+s1) % 2 == 0){
                if(s0 == 0) dp[dpcnt][0] = LONGBOI;
                else{
                    update = LONGBOI;
                    if(s0 > 1) update = min(update, max(dp[dpcnt-1][1], getDist({lastx, 1}, {xnow, 0})));
                    if(s1 > 0) update = min(update, max(dp[dpcnt-1][1], getDist({lastx, 1}, {xnow, 1})));
                    dp[dpcnt][0] = min(dp[dpcnt][0], update);
                }

                if(s1 == 0) dp[dpcnt][1] = LONGBOI;
                else{
                    update = LONGBOI;
                    if(s0 > 0) update = min(update, max(dp[dpcnt-1][1], getDist({lastx, 1}, {xnow, 0})));
                    if(s1 > 1) update = min(update, max(dp[dpcnt-1][1], getDist({lastx, 1}, {xnow, 1})));
                    dp[dpcnt][1] = min(dp[dpcnt][1], update);
                }
            }
            else{
                update = LONGBOI;
                if(s0 > 0) update = min(update, max(dp[dpcnt-1][1], getDist({lastx, 1}, {xnow, 0})));
                if(s1 > 0) update = min(update, max(dp[dpcnt-1][1], getDist({lastx, 1}, {xnow, 1})));
                dp[dpcnt][2] = min(dp[dpcnt][2], update);
            }
        }
    }

    //cout << "0 at the end : "; for(int i=0; i <= dpcnt; i++) cout << dp[i][0] << " "; cout << endl;
    //cout << "1 at the end : "; for(int i=0; i <= dpcnt; i++) cout << dp[i][1] << " "; cout << endl;
    //cout << "nothing at the end : "; for(int i=0; i <= dpcnt; i++) cout << dp[i][2] << " "; cout << endl;

    cout << dp[dpcnt][2] << endl;
    return 0;
}
