#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
const ll SIZ = ((ll)2e2+5), LONGBOI = ((ll)1e15+5);
mt19937_64 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

ll n, m;
ll a[SIZ][SIZ];

void setLine(ll x){
    if(m % 3 == 0){
        for(int i=1; i <= m; i+=3){
            a[x][i + 0] = 1;
            a[x][i + 1] = 1;
            a[x][i + 2] = 0;
        }
    }
    else if(m % 3 == 1){
        a[x][1] = 0;
        for(int i=2; i <= m; i+=3){
            a[x][i + 0] = 1;
            a[x][i + 1] = 1;
            a[x][i + 2] = 0;
        }
    }
    else if(m % 3 == 2){
        a[x][1] = 1;
        a[x][2] = 1;
        for(int i=3; i <= m; i+=3){
            a[x][i + 0] = 0;
            a[x][i + 1] = 1;
            a[x][i + 2] = 1;
        }
    }
}

void set2Lines(ll x){
    if(m % 3 == 0){
        for(int i=1; i <= m; i+=3){
            a[x][i + 0] = 1; a[x + 1][i + 0] = 1;
            a[x][i + 1] = 2; a[x + 1][i + 1] = 2;
            a[x][i + 2] = 2; a[x + 1][i + 2] = 2;
        }
    }
    else if(m % 3 == 1){
        a[x][1] = 1; a[x + 1][1] = 1;
        for(int i=2; i <= m; i+=3){
            a[x][i + 0] = 2; a[x + 1][i + 0] = 2;
            a[x][i + 1] = 2; a[x + 1][i + 1] = 2;
            a[x][i + 2] = 1; a[x + 1][i + 2] = 1;
        }
    }
    else if(m % 3 == 2){
        a[x][1] = 2; a[x + 1][1] = 2;
        a[x][2] = 2; a[x + 1][2] = 2;
        for(int i=3; i <= m; i+=3){
            a[x][i + 0] = 1; a[x + 1][i + 0] = 1;
            a[x][i + 1] = 2; a[x + 1][i + 1] = 2;
            a[x][i + 2] = 2; a[x + 1][i + 2] = 2;
        }
    }
}

void set3Lines(ll x){
    if(m % 3 == 0){
        for(int i=1; i <= m; i+=3){
            a[x][i + 0] = 1; a[x + 1][i + 0] = 1; a[x + 2][i + 0] = 0;
            a[x][i + 1] = 2; a[x + 1][i + 1] = 2; a[x + 2][i + 1] = 1;
            a[x][i + 2] = 2; a[x + 1][i + 2] = 2; a[x + 2][i + 2] = 1;
        }
    }
    else if(m % 3 == 1){
        a[x][1] = 1; a[x + 1][1] = 1; a[x + 2][1] = 0;
        for(int i=2; i <= m; i+=3){
            a[x][i + 0] = 2; a[x + 1][i + 0] = 2; a[x + 2][i + 0] = 1;
            a[x][i + 1] = 2; a[x + 1][i + 1] = 2; a[x + 2][i + 1] = 1;
            a[x][i + 2] = 1; a[x + 1][i + 2] = 1; a[x + 2][i + 2] = 0;
        }
    }
    else if(m % 3 == 2){
        a[x][1] = 2; a[x + 1][1] = 2; a[x + 2][1] = 1;
        a[x][2] = 2; a[x + 1][2] = 2; a[x + 2][2] = 1;
        for(int i=3; i <= m; i+=3){
            a[x][i + 0] = 1; a[x + 1][i + 0] = 1; a[x + 2][i + 0] = 0;
            a[x][i + 1] = 2; a[x + 1][i + 1] = 2; a[x + 2][i + 1] = 1;
            a[x][i + 2] = 2; a[x + 1][i + 2] = 2; a[x + 2][i + 2] = 1;
        }
    }
}

void setSquare(ll x){
    for(int i=1; i <= m; i++){
        a[x][i] = 2; a[x + 2][i] = 2;
    }
    a[x + 1][1] = 2; a[x + 1][m] = 2;


    if((m-2) % 3 == 0){
        for(int i=2; i <= m-1; i+=3){
            a[x+1][i + 0] = 1;
            a[x+1][i + 1] = 1;
            a[x+1][i + 2] = 0;
        }
    }
    else if((m-2) % 3 == 1){
        a[x+1][2] = 0;
        for(int i=3; i <= m-1; i+=3){
            a[x+1][i + 0] = 1;
            a[x+1][i + 1] = 1;
            a[x+1][i + 2] = 0;
        }
    }
    else if((m-2) % 3 == 2){
        a[x+1][2] = 1;
        a[x+1][3] = 1;
        for(int i=4; i <= m-1; i+=3){
            a[x+1][i + 0] = 0;
            a[x+1][i + 1] = 1;
            a[x+1][i + 2] = 1;
        }
    }
}

void setSquareAndLine(ll x){
    setSquare(x);
    setLine(x+3);
}

void setLineAndSquare(ll x){
    setLine(x);
    setSquare(x+1);
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> m;

    if(n <= 4){
        if(n == 1) { setLine(1); }
        if(n == 2) { set2Lines(1); }
        if(n == 3) { set3Lines(1); }
        if(n == 4) { setSquareAndLine(1); }
    }
    else{
        if(n % 4 == 0){
            for(int i=1; i<=n; i+=4) setSquareAndLine(i);
        }
        else if(n % 4 == 1){
            setLine(1);
            for(int i=2; i<=n; i+=4) setSquareAndLine(i);
        }
        else if(n % 4 == 2){
            set3Lines(1);
            set3Lines(4);
            for(int i=7; i<=n; i+=4) setSquareAndLine(i);
        }
        else if(n % 4 == 3){
            setSquare(1);
            for(int i=4; i<=n; i+=4) setLineAndSquare(i);
        }
    }

    for(int i=1; i <= n; i++){
        for(int j=1; j <= m; j++){
            cout << a[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
