#include <bits/stdc++.h>

using namespace std;

#define print(a) cerr << "[" << #a << " = " << (a) << "] "
#define dbg(a) print(a) << "\n"
#define dbg2(a, b) print(a); print(b) << "\n"
#define dbg3(a, b, c) print(a); print(b); print(c) << "\n"

#define int long long
#define ll long long
#define pi pair<int, int> 
#define sz(a) ((int)(a).size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define divup(a, b) (((a) + (b) - 1) / (b))

template <class T> bool chmax(T&a, const T&b) {return b > a ? a = b, 1 : 0;};
template <class T> bool chmin(T&a, const T&b) {return b < a ? a = b, 1 : 0;};

template <class T> using min_queue = priority_queue<T, vector<T>, greater<T>>;
template <class T> using max_queue = priority_queue<T, vector<T>, less<T>>;

const int mod = 1e9 + 7;
const int inf = (int)(1e18) + 7;
const int maxn = 2e5 + 7;
const int logn = 20;

void solve() {
    int n;
    cin >> n;
    n *= 2;

    vector <pi> a(n);
    int ans = 0, cnt1 = 0, cnt0 = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        if (a[i].second == 0) ++cnt0;
        else ++cnt1;
    }
    sort(all(a));
    for (auto x : a) cout << x.first << ' ' << x.second << '\n';
    for (int i = 0; i + 1 < n; ++i) {
        chmax(ans, a[i + 1].first - a[i].first);
    }
    if (cnt1 != 0) cout << 5 / 0 << '\n';
    else cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
    freopen("error.txt", "w", stderr);

    solve();
}