#include <bits/stdc++.h>

using namespace std;

#define print(a) cerr << "[" << #a << " = " << (a) << "] "
#define dbg(a) print(a) << "\n"
#define dbg2(a, b) print(a); print(b) << "\n"
#define dbg3(a, b, c) print(a); print(b); print(c) << "\n"

#define int long long
#define ll long long
#define pi pair<int, int> 
#define sz(a) ((int)(a).size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define divup(a, b) (((a) + (b) - 1) / (b))

template <class T> bool chmax(T&a, const T&b) {return b > a ? a = b, 1 : 0;};
template <class T> bool chmin(T&a, const T&b) {return b < a ? a = b, 1 : 0;};

template <class T> using min_queue = priority_queue<T, vector<T>, greater<T>>;
template <class T> using max_queue = priority_queue<T, vector<T>, less<T>>;

const int mod = 1e9 + 7;
const int inf = (int)(1e18) + 7;
const int maxn = 2e5 + 7;
const int logn = 20;

map <int, int> mp[2];

void solve() {
    int n;
    cin >> n;
    n *= 2; 

    vector <pi> a(n);
    vector <int> b;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        b.push_back(a[i].first);
        mp[a[i].second][a[i].first]++;
        if (mp[a[i].second][a[i].first] > 2) mp[a[i].second][a[i].first] -= 2;
    }
    sort(all(b));
    b.resize(unique(all(b)) - b.begin());
    vector <int> c = b;
    sort(rall(c));
    // for (auto x : b) dbg(x);
    // for (auto x : c) dbg(x);

    bool f = 0;
    for (auto x : b) {
        c.pop_back();
        int cnt0 = mp[0][x];
        int cnt1 = mp[1][x];
        // dbg2(cnt0, cnt1);
        int cnt = cnt0 + cnt1 - f;
        if (cnt % 2 == 0) {
            if (f) {
                f = 0;
                continue;
            }
            if (cnt0 & 1) chmax(ans, 1LL);
            continue;
        } else {
            int nxt = c.back();
            int t = -1;
            if (mp[0][nxt] && mp[1][nxt]) t = 2;
            else if (mp[0][nxt]) t = 0;
            else t = 1;
            if (f) {
                if (t == 2) chmax(ans, nxt - x);
                else if (t == 0) {
                    if (cnt0) chmax(ans, nxt - x);
                    else chmax(ans, nxt - x + 1);
                } else {
                    if (cnt1) chmax(ans, nxt - x);
                    else chmax(ans, nxt - x + 1);
                }
            } else {
                if (t == 2) chmax(ans, nxt - x);
                else if (t == 0) {
                    if (cnt0) chmax(ans, nxt - x);
                    else chmax(ans, nxt - x + 1);
                } else {
                    if (cnt1) chmax(ans, nxt - x);
                    else chmax(ans, nxt - x + 1);
                }
            }
            f = 1;
            continue;
        }
    }
    cout << ans << '\n';
    // return;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
    freopen("error.txt", "w", stderr);

    solve();
}