#include <bits/stdc++.h>

using namespace std;

#define print(a) cerr << "[" << #a << " = " << a << "] "
#define dbg(a) print(a) << "\n"
#define dbg2(a, b) print(a); print(b) << "\n"
#define dbg3(a, b, c) print(a); print(b); print(c) << "\n"

#define int long long
#define ll long long
#define pi pair<int, int> 
#define sz(a) ((int)(a).size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define divup(a, b) (((a) + (b) - 1) / (b))

template <class T> bool chmax(T&a, const T&b) {return b > a ? a = b, 1 : 0;};
template <class T> bool chmin(T&a, const T&b) {return b < a ? a = b, 1 : 0;};

template <class T> using min_queue = priority_queue<T, vector<T>, greater<T>>;
template <class T> using max_queue = priority_queue<T, vector<T>, less<T>>;

const int mod = 1e9 + 7;
const int inf = (int)(1e18) + 7;
const int maxn = 2e5 + 7;
const int logn = 20;

const int N = 200 + 7;

int a[N][N];

vector<int> get(int cnt) {
    vector <int> res;
    if (cnt % 3 == 0) {
        for (int i = 0; i < cnt / 3; ++i) {
            res.push_back(0);
            res.push_back(1);
            res.push_back(1);
        }
    } else if (cnt % 3 == 1) {
        for (int i = 0; i < cnt / 3; ++i) {
            res.push_back(0);
            res.push_back(1);
            res.push_back(1);
        }
        res.push_back(0);
    } else {
        res.push_back(1);
        res.push_back(1);
        for (int i = 0; i < cnt / 3; ++i) {
            res.push_back(0);
            res.push_back(1);
            res.push_back(1);
        }
    }
    return res;
}

void rec(int i, int j, int n, int m) {
    if (n == 1) {
        vector <int> res = get(m);
        for (int nj = j; nj <= j + m; ++nj) {
            a[i][nj] = res[nj - j]; 
        }
        return;
    }
    if (m == 1) {
        vector <int> res = get(n);
        for (int ni = i; ni <= i + n; ++ni) {
            a[ni][j] = res[ni - i]; 
        }
        return;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    vector <int> t0 = get(m);
    vector <int> t1 = get(m);
    for (int i = 0; i < sz(t1); ++i) {
        if (t1[i] == 0) t1[i] = 1;
        else t1[i] = 2;
    }
    vector <int> res = get(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (res[i] == 0) cout << t0[j] << " ";
            else cout << t1[j] << " ";
        }cout << "\n";
    }

    // rec(0, 0, n, m);
    // for (int i = 0; i < n; ++i) {
    //     for (int j = 0; j < m; ++j) {
    //         cout << a[i][j] << " "; 
    //     } cout << "\n";
    // }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
    freopen("error.txt", "w", stderr);

    solve();
}