#include <bits/stdc++.h>

using namespace std;

#define print(a) cerr << "[" << #a << " = " << a << "] "
#define dbg(a) print(a) << "\n"
#define dbg2(a, b) print(a); print(b) << "\n"
#define dbg3(a, b, c) print(a); print(b); print(c) << "\n"

#define int long long
#define ll long long
#define pi pair<int, int> 
#define sz(a) ((int)(a).size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define divup(a, b) (((a) + (b) - 1) / (b))

template <class T> bool chmax(T&a, const T&b) {return b > a ? a = b, 1 : 0;};
template <class T> bool chmin(T&a, const T&b) {return b < a ? a = b, 1 : 0;};

template <class T> using min_queue = priority_queue<T, vector<T>, greater<T>>;
template <class T> using max_queue = priority_queue<T, vector<T>, less<T>>;

const int mod = 1e9 + 7;
const int inf = (int)(1e18) + 7;
const int maxn = 2e5 + 7;
const int logn = 20;


void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;

    int cnta = 0, cntb = 0, cntc = 0, ans = 0;
    vector<int> b, c;
    for (int i = 0; i < n; ++i) {
        if (i == 0 || s[i] != s[i - 1]) {
            if (s[i] == 'A') b.push_back(0);
            else if (s[i] == 'B') b.push_back(1);
            else b.push_back(2);
            c.push_back(1);
        } else {
            c.back()++;
        }
    }
    auto check = [&](int i) {
        if (i < 2) return 1;
        if (b[i - 2] == 0 && b[i - 1] == 2 && b[i] == 1) {
            return 0;
        }
        if (b[i - 2] == 1 && b[i - 1] == 0 && b[i] == 2){
            return 0;
        }
        if (b[i - 2] == 2 && b[i - 1] == 1 && b[i] == 0) return 0;
        return 1;
    };
    n = sz(b);
    vector <int> cnt(3, 0);
    for (int i = 0; i < n; ++i) {
        ++cnt[b[i]];
        if (!check(i)) {
            --cnt[b[i]];
            --cnt[b[i - 1]];
        }
        if (i == n - 1 || !check(i)) {
            ans += max(cnt[0] * cnt[1], cnt[1] * cnt[2]);
            cnt = vector<int>(3, 0);
        }
    }

    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
    freopen("error.txt", "w", stderr);

    int t;
    cin >> t;
    while (t--) {
        solve();
        cerr << "###############";
    }
}