#include <bits/stdc++.h>

using namespace std;

#define print(a) cerr << "[" << #a << " = " << a << "] "
#define dbg(a) print(a) << "\n"
#define dbg2(a, b) print(a); print(b) << "\n"
#define dbg3(a, b, c) print(a); print(b); print(c) << "\n"

#define int long long
#define ll long long
#define pi pair<int, int> 
#define sz(a) ((int)(a).size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define divup(a, b) (((a) + (b) - 1) / (b))

template <class T> bool chmax(T&a, const T&b) {return b > a ? a = b, 1 : 0;};
template <class T> bool chmin(T&a, const T&b) {return b < a ? a = b, 1 : 0;};

template <class T> using min_queue = priority_queue<T, vector<T>, greater<T>>;
template <class T> using max_queue = priority_queue<T, vector<T>, less<T>>;

const int mod = 1e9 + 7;
const int inf = (int)(1e18) + 7;
const int maxn = 1e5 + 7;
const int logn = 20;

bool pr[maxn];

void prec() {
    for (int x = 2; x < maxn; ++x) {
        bool g = 1;
        for (int i = 2; i * i <= x; ++i) {
            if (x % i == 0) {
                g= 0;
                break;
            }
        }
        pr[x] = g;
    }
}

vector <vector <int>> t;
vector <vector <int>> res;
vector <int> sum;
int ans = inf;

int a[maxn];
int n, k;

void rec(int i, int cur = 0) {
    if (sz(t) > k) return;
    // cout << i << "\n";
    // for (auto b : t) {
    //     for (auto x : b) cout << x << " ";
    //     cout << "\n";
    //     cout << "\n";
    // }
    if (i == n) {
        if (sz(t) < k) return;
        if (cur < ans) {
            ans = cur;
            res = t;
        }
        return;
    }
    for (int j = 0; j < sz(t); ++j) {
        cur -= pr[sum[j]];
        sum[j] += a[i];
        t[j].push_back(a[i]);
        cur += pr[sum[j]];
        rec(i + 1, cur);
        cur -= pr[sum[j]];
        t[j].pop_back();
        sum[j] -= a[i];
        cur += pr[sum[j]];
    }
    cur += pr[a[i]];
    sum.push_back(a[i]);
    t.push_back({a[i]});
    rec(i + 1, cur);
    cur -= pr[a[i]];
    sum.pop_back();
    t.pop_back();
}

void solve() {
    cin >> n >> k;
    dbg2(n, k);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    ans = inf;
    res.clear();
    rec(0);
    cout << ans << "\n";
    for (auto b : res) {
        cout << sz(b) << " ";
        for (auto x : b) cout << x << " ";
        cout << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
    freopen("error.txt", "w", stderr);

    prec();
    int t;
    cin >> t;
    while (t--) {
        solve();
        cerr << "###############";
    }
}