#include <bits/stdc++.h>
using namespace std;

const int DIM = 1e5;

struct Dot{
    int x, y;
} dots[DIM * 2];
int q_pairs;

bool comp(Dot& A, Dot& B){
    return A.x < B.x || (A.x == B.x && A.y < B.y);
}

void input(){
    cin >> q_pairs;
    for (int i = 0; i < q_pairs*2; ++i)
        cin >> dots[i].x >> dots[i].y;
}

int dist(Dot& A, Dot& B){
    return abs(A.x - B.x) + abs(A.y - B.y);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    input();
    sort(dots, dots + q_pairs * 2, comp);

    int max_dist = 0;
    for (int i = 0; i < q_pairs; ++i){
        max_dist = max(max_dist, dist(dots[i*2], dots[i*2+1]));
    }

    cout << max_dist << '\n';

    return 0;
}
