#include <bits/stdc++.h>
using namespace std;

const int DIM = 1e5;
int arr[DIM], len, q_subs, q_strange;
vector<int> subsequences[DIM];

bool is_prime(long long num){
    for (int i = 2; i <= sqrt(num); ++i)
        if (num % i == 0)
            return false;
    return true;
}

void input(){
    cin >> len >> q_subs;
    for (int i = 0; i < len; ++i)
        cin >> arr[i];
    q_strange = 0;
}

void solve(){
    int q_2 = 0;
    for (int i = 0; i < len; ++i)
        if (arr[i] == 2)
            ++q_2;
    
    int q_len_2 = len - q_subs;
    int q_len_1 = q_subs - q_len_2;

    q_strange = abs(q_len_1 - q_2);
    for (int i = 0; i < q_len_1; ++i){
        subsequences[i].clear();
        subsequences[i].push_back(arr[i]);
    }
    int i = q_len_1;
    int ind = q_len_1;
    while (i < len && ind < q_subs){
        subsequences[ind].clear();
        subsequences[ind].push_back(arr[i++]);
        subsequences[ind++].push_back(arr[i++]);
    }
}

void output(){
    cout << q_strange << '\n';
    for (int i = 0; i < q_subs; ++i){
        cout << subsequences[i].size() << ' ';
        for (int el : subsequences[i])
            cout << el << ' ';
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int q_test; cin >> q_test;
    for (int i = 0; i < q_test; ++i){
        input();
        solve();
        output();
    }
}
