import sys

sys.setrecursionlimit(10000)
memo = {}
def find_longest_operation_chain(s):
    global memo
    if s in memo:
        return memo[s]
    max_operations = 0
    branches = []
    for i in range(len(s)-1):
        sub = s[i:i+2]
        if sub in ['AB', 'BC', 'CA']:
            branch = s[:i] + sub[::-1] + s[i+2:]
            branches.append(branch)
    
    if len(branches) == 0:
        memo |= {s: 0}
        return 0
    for branch in branches:
        max_operations = max(max_operations, 1 + find_longest_operation_chain(branch))
    memo |= {s: max_operations}
    return max_operations

T = int(sys.stdin.readline())
for _ in range(T):
    sys.stdin.readline()
    s = sys.stdin.readline().strip()
    print(find_longest_operation_chain(s))
    