#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

ll dist(const pair<ll,ll> &first,const pair<ll,ll> &second){
    return abs(first.first-second.first)+abs(first.second-second.second);
}

void print_row(ll m){
    if (m%3==2){
        cout<<"1 1 ";
    }
    for (ll i=0;i<m/3;i++){
        cout<<"0 1 1 ";
    }
    if (m%3==1){
        cout<<"0 ";
    }
    cout<<nl;
}

void print_2row(ll m){
    for (ll j=0;j<2;j++){
        if (m%3 == 2){
            cout<<"2 2 ";
        }
        for (ll i=0;i<m/3;i++){
            cout<<"1 2 2 ";
        }
        if (m%3 == 1){
            cout<<"1 ";
        }
        cout<<nl;
    }
}

void solve(){
    ll n;
    string str;
    cin>>n;
    cin>>str;
    vector<ll> prefix_A(n+1);
    vector<ll> prefix_B(n+1);
    vector<ll> prefix_C(n+1);
    prefix_A[0]=0;
    prefix_B[0]=0;
    prefix_C[0]=0;
    ll ans=0;
    for (ll i=1;i<n;i++){
        if (str[i]=='A'){
            ans+=str[i-1]=='C';
        }else if (str[i]=='B'){
            ans+=str[i-1]=='A';
        }else if (str[i]=='C'){
            ans+=str[i-1]=='B';
        }
    }
    cout<<(ans>0)<<nl;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("in","r",stdin);
    ll a,b,c,d,e;
    ll n,m,k;
    ll t;
    cin>>t;
    while (t--){
        solve();
    }
}