import sys
from math import sqrt, pow

def getDistance(x1, y1, x2, y2):
    return (max(x1, x2) - min(x1, x2)) + (max(y1, y2) - min(y1, y2))

n = int(sys.stdin.readline())

allPoints = list()

for i in range(n*2): 
    allPoints.append(list(map(int, sys.stdin.readline().split())))

pairs = list()

while True:
    x1, y1 = allPoints[0][0], allPoints[0][1]
    allPoints.pop(0)
    x2, y2 = allPoints[0][0], allPoints[0][1]
    distance = getDistance(x1, y1, x2, y2)
    pair = 0
    for i in range(1, len(allPoints)):
        if distance > getDistance(x1, y1, allPoints[i][0], allPoints[i][1]):
            pair = i
            x2, y2 = allPoints[i][0], allPoints[i][1]
    allPoints.pop(pair)
    pairs.append([[x1, y1], [x2, y2]])
    if len(allPoints) == 0: break

highestDistance = getDistance(pairs[0][0][0], pairs[0][0][1], pairs[0][1][0], pairs[0][1][1])

for i in pairs[1::]:
    distance = getDistance(i[0][0], i[0][1], i[1][0], i[1][1])
    if highestDistance < distance:
        highestDistance = distance

print(highestDistance)