#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <numeric>
#include <climits>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <cstdint>
using namespace std;

struct Point
{
    int x, y;

    friend bool operator<(const Point& p1, const Point& p2)
    {
        if (p1.x < p2.x)
        {
            return 1;
        }
        if (p1.x > p2.x) return 0;
        return p1.y < p2.y;
    }
};

void solve()
{
    int n;
    cin >> n;
    vector<Point> P(2*n);
    map<Point, int> M;

    int count1 = 0;
    int count0 = 0;
    for (int i=0; i<P.size(); i++)
    {
        cin >> P[i].x >> P[i].y;
        if (P[i].y == 0) count0++;
        else if (P[i].y == 1) count1++;

        M[P[i]]++;
    }

    sort(P.begin(), P.end());

    if (n == 1)
    {
        cout << abs(P[0].x-P[1].x) + abs(P[0].y-P[1].y);
        return;
    }

    if (P[0].x == P[2*n-1].x)
    {
        if (count1%2 == 0 && count0%2 == 0)
        {
            cout << 0 << endl;
        }
        else cout << 1 << endl;
        return;
    }

    vector<Point> vec;
    for (auto p : M)
    {
        if (p.second % 2 == 0) continue;
        vec.push_back(p.first);
    }

    int mx = 0;
    for (int i=0; i<vec.size(); i+=2)
    {
        mx = max(mx, abs(vec[i].x-vec[i+1].x) + abs(vec[i].y-vec[i+1].y));
    }

    cout << mx << endl;

    // G5 & G6
    // int mx = 0;
    // for (int i=0; i<2*n-1; i+=2)
    // {
    //     mx = max(mx, abs(P[i].x-P[i+1].x) + abs(P[i].y-P[i+1].y));
    // }

    // cout << mx << endl;



}

int main()
{
    solve();
}