#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <numeric>
#include <climits>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <cstdint>
using namespace std;

bool isPrime(int64_t x)
{
    int64_t to = sqrt(x);
    for (int i=2; i<=to; i++)
    {
        if (x%i == 0) return 0;
    }
    return 1;
}

void solve()
{
    int n, k;
    cin >> n >> k;

    vector<int64_t> A(n);
    
    int64_t sum = 0;
    for (int i=0; i<n; i++)
    {
        cin >> A[i];
        sum += A[i];
    }

    if (k == 1)
    {
        if (isPrime(sum) == 0)
        {
            cout << 0 << endl;
        }
        else cout << 1 << endl;
        cout << n << " ";
        for (int64_t i : A)
        {
            cout << i << ' ';
        }
        cout << endl;
        return;
    }
}

int main()
{
    int t;
    cin >> t;
    while (t--) solve();   
}