#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <numeric>
#include <climits>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <cstdint>
using namespace std;

bool isPrime(int64_t x)
{
    int64_t to = sqrt(x);
    for (int i=2; i<=to; i++)
    {
        if (x%i == 0) return 0;
    }
    return 1;
}

void solve()
{
    int n, k;
    cin >> n >> k;

    vector<int64_t> A(n);
    
    int64_t sum = 0;
    int count2 = 0;
    for (int i=0; i<n; i++)
    {
        cin >> A[i];
        sum += A[i];
        if (A[i] == 2) count2++;
    }

    if (k == 1)
    {
        if (isPrime(sum) == 0)
        {
            cout << 0 << endl;
        }
        else cout << 1 << endl;
        cout << n << " ";
        for (int64_t i : A)
        {
            cout << i << ' ';
        }
        cout << endl;
        return;
    }

    if (k == n)
    {
        cout << n << endl;
        for (int64_t i : A)
        {
            cout << "1 " << i << endl;
        }
        return;
    }

    if (n%2 == 0 && count2 == 0)
    {
        if (2*k <= n)
        {
            cout << "0\n";
            int j = 0;
            for (int i=0; i<k-1; i++)
            {
                cout << "2 " << A[j] << " " << A[j+1];
                j+=2;
                cout << endl;
            }
            cout << n - 2*(k-1) << ' ';
            for (; j<n; j++)
            {
                cout << A[j] << ' ';
            }
            cout << endl;
        }
        else
        {
            cout << k - (n-k) << endl;
            int j = 0;
            for (int i=0; i<n-k; i++)
            {
                cout << "2 " << A[j] << " " << A[j+1];
                j += 2;
                cout << endl;
            }
            for (; j<n; j++)
            {
                cout << "1 " << A[j] << endl;
            }
            cout << endl;
        }
    }

}

int main()
{
    int t;
    cin >> t;
    while (t--) solve();   
}