#include <bits/stdc++.h>
#define int long long
using namespace std;

const int INF = 1e9 + 7;

void solve(){
    int n; cin >> n;
    vector<pair<int, int>> a;
    for(int i = 0; i < 2*n; i++){
        int x, y; cin >> x >> y;
        a.push_back({x, y});
    }
    sort(begin(a), end(a));
    vector<int> dp(2*n+1, INF);
    a.push_back({0, 0});
    a.push_back({0, 0});
    dp[1] = abs(a[0].first - a[1].first) + abs(a[1].second - a[0].second);
    for(int i = 3; i < 2*n-1; i++){
        int tmpx1 = a[i].first, tmpy1 = a[i].second;
        int tmpx2 = a[i-1].first, tmpy2 = a[i-1].second;
        int tmpx3 = a[i+1].first, tmpy3 = a[i+1].second;

        int t1 = abs(tmpx1 - tmpx2) + abs(tmpy1 - tmpy2);
        int t2 = abs(tmpx3 - tmpx1) + abs(tmpy3 - tmpy1);

        if(dp[i-1] != INF && t1 < t2){
            dp[i] = t1;
        }else{
            dp[i] = t2;
        }
    }
    int mx = 0;
    for(auto x: dp){
        if(x != INF) mx = max(mx, x);
    }
    cout << mx << endl;
}

signed main(){
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);
    int t = 1; //cin >> t;
    while(t--) solve();
}
