import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class Task4 {
    public static final boolean[] SIMPLE_NUMBERS = new boolean[10000];
    static {
        Arrays.fill(SIMPLE_NUMBERS, true);
        for(int i = 2; i < 10000; i++) {
            for(int j = i * 2; j < 10000; j += i) {
                SIMPLE_NUMBERS[j] = false;
            }
        }
    }
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer(br.readLine());
        int T = Integer.parseInt(st.nextToken());
        for(int i = 0; i< T; i++) {
            st = new StringTokenizer(br.readLine());
            int n = Integer.parseInt(st.nextToken());
            int k = Integer.parseInt(st.nextToken());
            int[] a = new int[n];
            st = new StringTokenizer(br.readLine());
            for(int j = 0; j < n; j++) {
                a[j] = Integer.parseInt(st.nextToken());
            }
            if(k == 1) {
                System.out.println(checkForSimple(a, 0, n) ? 1 : 0);
                System.out.print(n + " ");
                for (int num : a) {
                    System.out.print(num + " ");
                }
                System.out.println();
            }
        }
    }
    private static boolean checkForSimple(int[] arr, int start, int end) {
        int sum = 0;
        for(int i = start; i < end; i++) {
            sum += arr[i];
        }
        return SIMPLE_NUMBERS[sum];
    }
}

/*
1
3 1
5 5 13
 */