from sys import stdin
from math import isqrt
from random import randint
from time import monotonic
def is_prime(n):
    if n == 1: return False
    for i in range(2, isqrt(n)):
        if n % i == 0:
            return False
    return True
t = int(stdin.readline())


def solve():
    
    n, k = list(map(int, stdin.readline().split()))
    a = list(map(int, stdin.readline().split()))
    if k == 1:
        print(int(is_prime(sum(a))))
        print(n, *a)
        return
    m = 99
    d = [None for _ in range(k-1)]
    s = monotonic()
    while monotonic() - s <= 0.8/t or m == 0:
        ans = 0
        minr = 0
        for i in range(k-1): 
            d[i] = randint(minr+1, n-k+i + 1)
            minr = d[i]

        if is_prime(sum(a[0:d[0]])): ans += 1
        for i in range(k-2):
            if is_prime(sum(a[d[i]:d[i+1]])): ans += 1
        if is_prime(sum(a[d[-1]: n])): ans += 1
        m = min(ans, m)
    print(m)
    print(d[0], *a[0:d[0]])
    for i in range(0, k-2):
        print(d[i+1] - d[i], *a[d[i]:d[i+1]])
    if k != 1:
        print(n - d[-1], *a[-1:d[-1]-1:-1])


for _ in range(t):
    solve()