#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;
const ll DIM = 2*1e5+7;
const ll INF = 1e18;
ll n;
pll a[DIM];
ll ans = 0;
ll gt(ll i, ll j){
    return abs(a[i].first - a[j].first) + abs(a[i].second - a[j].second);
}
ll simulate(ll x, ll flag){
    ll L = 0, R = 0;
    if(flag == 0){
        L = x;
        R = x+2;
    } else if(flag == 1){
        L = x;
        R = x+1;
    }

    if(L > 2*n || R > 2*n) return -INF;
    
    if(a[R].first == a[R+1].first && R+1 <= 2*n){
        ll mx = INF;
        for(ll j=R; j<=2*n; j++){
            if(j == R) mx = min(mx, max(gt(L, j), simulate(j+1, 1)));
            if(j == R+1) mx = min(mx, max(gt(L, j), simulate(L+1, 2)));
            else mx = min(mx, max(gt(L, j), simulate(L+1, 1)));
        }
        return mx;
    } else {
        return max(gt(L, R), simulate(L+2, 1));
    }
}
void dfs(ll mx, ll used[DIM], ll pr){
    if(pr == n){
        ans = min(ans, mx);
        return;
    }
    for(int i=1; i<2*n; i++){
        if(used[i] == 0){
            for(int j=1; j<=2*n; j++){
                if(i == j) continue;

                if(used[j] == 0){
                    used[i] = 1;
                    used[j] = 1;

                    dfs(max(mx, gt(i, j)), used, pr + 1);

                    used[i] = 0;
                    used[j] = 0;
                }
            }
        }
    }
}
int main(){
    cin >> n;
    for(int i=1; i<=2*n; i++) cin >> a[i].first >> a[i].second;
    sort(a+1, a+1+2*n);

    ans = 0;
    ans = simulate(1, 1);
    
    cout << ans << endl;
    return 0;
}