#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define len(v) (int) (v.size())

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        in >> v[i];
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        out << v[i] << ' ';
    }
    return out;
}

template<typename T, typename U>
bool chmin(T& a, U b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

const int INF = 1e18;
void solve() {
    int n;
    cin >> n;
    map<int, array<int, 2>> cnt;
    vector<int> coord;
    for (int i = 0; i < 2 * n; i++) {
        int x, y;
        cin >> x >> y;
        cnt[x][y]++;
        coord.push_back(x);
    }

    sort(all(coord));
    coord.erase(unique(all(coord)), coord.end());

    int m = len(coord);
    vector dp(m + 1, vector(3, INF));
    dp[0][0] = 1;

    for (int i = 0; i < m; i++) {
        for (int x = 0; x < 3; x++) {
            if (dp[i][x] == INF) continue;
            int cnt0 = cnt[coord[i]][0] - (x == 1);
            int cnt1 = cnt[coord[i]][1] - (x == 2);

            if ((cnt0 + cnt1) % 2 == 0) {
                chmin(dp[i + 1][0], max(dp[i][x], cnt0 % 2));
            }
            else {
                int cnt2 = cnt[coord[i + 1]][0];
                int cnt3 = cnt[coord[i + 1]][1];
                int delta = coord[i + 1] - coord[i];
                if (cnt0 > 0) {
                    if (cnt2 > 0) {
                        chmin(dp[i + 1][1], max(dp[i][x], delta));
                    }
                    if (cnt3 > 0) {
                        chmin(dp[i + 1][2], max(dp[i][x], delta + 1));
                    }
                }
                if (cnt1 > 0) {
                    if (cnt2 > 0) {
                        chmin(dp[i + 1][1], max(dp[i][x], delta + 1));
                    }
                    if (cnt3 > 0) {
                        chmin(dp[i + 1][2], max(dp[i][x], delta));
                    }
                }
            }
        }
    }

    cout << dp[m][0] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}