#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define len(v) (int) (v.size())

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        in >> v[i];
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (int i = 0; i < len(v); i++) {
        out << v[i] << ' ';
    }
    return out;
}

template<typename T, typename U>
bool chmin(T& a, U b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename U>
bool chmax(T& a, U b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

bool is_prime(int n) {
    for (int i = 2; i * i <= n; i++) {
        if (n % i == 0) return false;
    }
    return true;
}
#define bit(n, i) (((n) >> i) & 1)

const int INF = 1e18;
void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    cin >> a;

    int m = accumulate(all(a), 0ll);
    vector<int> is_prime(m + 1, true);
    is_prime[0] = is_prime[1] = false;
    for (int i = 2; i <= m; i++) {
        if (!is_prime[i]) continue;
        for (int j = i + i; j <= m; j += i) {
            is_prime[j] = false;
        }
    }

    vector dp(k + 1, vector(1 << n, INF)), prev = dp;
    dp[0][0] = 0;
    for (int i = 0; i < k; i++) {
        for (int mask = 0; mask < (1 << n); mask++) {
            for (int mask1 = 1; mask1 < (1 << n); mask1++) {
                if (mask & mask1) continue;
                int sm = 0;
                for (int j = 0; j < n; j++) {
                    if (bit(mask1, j)) sm += a[j];
                }
                int mask2 = mask | mask1;
                if (chmin(dp[i + 1][mask2], dp[i][mask] + is_prime[sm])) {
                    prev[i + 1][mask2] = mask;
                }
            }
        }
    }

    int i = k, mask = (1 << n) - 1;
    cout << dp[i][mask] << '\n';
    while (i > 0) {
        int mask1 = prev[i][mask];
        vector<int> b;
        for (int j = 0; j < n; j++) {
            if (bit(mask, j) && !bit(mask1, j)) {
                b.push_back(a[j]);
            }
        }
        cout << len(b) << ' ' << b << '\n';
        i--;
        mask = mask1;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}