#include <bits/stdc++.h>
using namespace std;

bool is_prime(long long n) {
    for (int i = 2; i <= sqrt(n); i++) {
        if (n % i == 0) return false;
    }
    return true;
}

int f(vector <int> v) {
    long long x, sum, ans = 0;
    for (int id = 0; id < (1<<v.size()); id++) {
        x = id;
        sum = 0;
        for (int i = 0; i < v.size(); i++) {
            if (x % 2 == 1) sum += v[i];
            x /= 2;
        }
        if (is_prime(sum)) ans++;
    }
    return ans;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector <int> v(n);
    for (int i = 0; i < n; i++) cin >> v[i];
    sort(v.begin(), v.end());

    if (k == 1) {
        cout << f(v) << "\n" << n << " ";
        for (int i = 0; i < n; i++) cout << v[i] << " ";
        cout << "\n";
        return;
    }
    if (true) {
        long long ans = 0;
        vector <int> a, b;
        long long x;
        for (int i = 0; i < v.size(); i++) {
            if (i % 2 == 1) a.push_back(v[i]);
            else b.push_back(v[i]);
        }
        
        cout << f(a)+f(b) << "\n" << a.size() << " ";
        for (int i = 0; i < a.size(); i++) cout << a[i] << " ";
        cout << "\n" << b.size() << " ";
        for (int i = 0; i < b.size(); i++) cout << b[i] << " ";
        cout << "\n";
        return;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) solve();
}
