#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>

using namespace std;
using ll = long long;

struct Vec2 {
    int x;
    int y;
};

int main() {
#ifndef DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n;
    cin >> n;

    vector<Vec2> points(n * 2);

    for (auto& point : points) {
        cin >> point.x >> point.y;
    }

    sort(points.begin(), points.end(), [&](const Vec2& a, const Vec2& b) {
        return a.x < b.x;
    });

    int res = 0;

    for (int i = 0; i < n; i++) {
        res = max(res, points[i * 2 + 1].x - points[i * 2].x + abs(points[i * 2].y - points[i * 2 + 1].y));
    }

    cout << res << "\n";

    return 0;
}
