#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>

using namespace std;
using ll = long long;

int main() {
#ifndef DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m;
    cin >> n >> m;

    auto get_pattern = [&](int x) {
        vector<int> pattern(x);

        if (x % 3 == 0) {
            for (int i = 0; i < x; i += 3) {
                pattern[i] = 0;
                pattern[i + 1] = 1;
                pattern[i + 2] = 1;
            }
        } else if (x % 3 == 1) {
            for (int i = 0; i < x - 1; i += 3) {
                pattern[i] = 0;
                pattern[i + 1] = 1;
                pattern[i + 2] = 1;
            }

            pattern[x - 1] = 0;
        } else if (x % 3 == 2) {
            for (int i = 0; i < x - 2; i += 3) {
                pattern[i] = 1;
                pattern[i + 1] = 1;
                pattern[i + 2] = 0;
            }

            pattern[x - 2] = 1;
            pattern[x - 1] = 1;
        }

        return pattern;
    };

    vector<int> n_pattern = get_pattern(n);
    vector<int> m_pattern = get_pattern(m);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << n_pattern[i] + m_pattern[j] << " ";
        }

        cout << "\n";
    }

    return 0;
}
