#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <string>

using namespace std;
using ll = long long;

void handle_test() {
    int n;
    cin >> n;

    string s;
    cin >> s;

    function<int(string&)> count_ops = [&](string& str) {
        int res = 0;

        while (true) {
            int curr_res = 0;

            for (int i = 0; i < str.length() - 1; i++) {
                if (str[i + 1] - 'A' == (str[i] - 'A' + 1) % 3) {
                    swap(str[i], str[i + 1]);
                    curr_res += 1;
                }
            }

            res += curr_res;
        }

        return res;
    };

    cout << count_ops(s) << "\n";
}

int main() {
#ifndef DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int tests;
    cin >> tests;

    while (tests--) {
        handle_test();
    }

    return 0;
}
