#include <iostream>
#include <vector>
const int sz = 1000001;
bool prime[sz];
int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    for (int i = 0; i < sz; ++i) {
        prime[i] = true;
    }
    for (int k = 2; k < sz; ++k) {
        if (!prime[k]) {
            ++k;
            continue;
        }
        for (int i = 2; i * k < sz; ++i) {
            prime[i*k] = false;
        }
    }
    while (t--) {
        int n, k;
        std::cin >> n >> k;
        std::vector<int> a(n);
        int sum = 0;
        for (int i = 0; i < n; ++i) {
            std::cin >> a[i];
            sum += a[i];
        }
        std::cout << (prime[sum] ? 1 : 0) << '\n';
    }
    return 0;
}