#include <iostream>
#include <vector>
#define int long long
const int sz = 1e5+1;
bool prime[sz];
signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    for (int i = 0; i < sz; ++i) {
        prime[i] = true;
    }
    for (int k = 2; k < sz; ++k) {
        if (!prime[k]) {
            ++k;
            continue;
        }
        for (int i = 2; i * k < sz; ++i) {
            prime[i*k] = false;
        }
    }
    while (t--) {
        int n, k;
        std::cin >> n >> k;
        std::vector<int> a(n);
        int sum = 0;
        for (int i = 0; i < n; ++i) {
            std::cin >> a[i];
            sum += a[i];
        }
        if (k == 1) {
            std::cout << (prime[sum] ? 1 : 0) << '\n';
        } else if (k == 2) {
            bool ans = true;
            for (int mask = 0; mask < (1 << n); ++mask) {
                int sum = 0, c = 0;
                for (int i = 0; i < n; ++i) {
                    if (mask & (1 << i)) {
                        sum += a[i];
                        ++c;
                    }
                }
                if (!prime[sum] && (c == 3)) {
                    ans = false;
                    break;
                }
            }
            std::cout << (ans ? 2 : 1) << '\n';
        } else if (k == 3) {
            bool ans = true;
            for (int mask = 0; mask < (1 << n); ++mask) {
                int sum = 0, c = 0;
                for (int i = 0; i < n; ++i) {
                    if (mask & (1 << i)) {
                        sum += a[i];
                        ++c;
                    }
                }
                if (!prime[sum] && (c == 2)) {
                    ans = false;
                    break;
                }
            }
            std::cout << (ans ? 3 : 2) << '\n';
        } else {
            std::cout << 4 << '\n';
        }
    }
    return 0;
}