#include <bits/stdc++.h>
using namespace std;

bool check(vector<vector<char>>& mat) {
    if (mat.empty()) {
        return true;
    }
    int n = mat.size();
    int m = mat[0].size();
    if (m == 0) {
        return true;
    }
    vector<int> dx = {-1, 0, 1, 0};
    vector<int> dy = {0, -1, 0, 1};
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int cnt = 0;
            for (int d = 0; d < 4; d++) {
                int nx = i + dx[d];
                int ny = j + dy[d];
                if (nx >= 0 && nx < n && ny >= 0 && ny < m && mat[nx][ny] == mat[i][j]) {
                    cnt++;
                }
            }
            if ((char)cnt != mat[i][j]) {
                return false;
            }
        }
    }
    return true;
}

int main() {
    // freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin>>n>>m;
    vector<string> subaru = {"0110110110110110110110110110","11011011011011011011011011011", "011011011011011011011011011011"};
    vector<vector<char>> mat1(n, vector<char>(m, '2')), mat2(n, vector<char>(m, '2'));
    for (int i = 0; i < n;i++) {
        if (i % 2 == 1) {
            for (int j = 0; j < m - 2; j++) {
                mat1[i][j + 1] = subaru[m - 30][j];
            }
        }
        if (i % 2 == 0) {
            for (int j = 0; j < m - 2; j++) {
                mat2[i][j + 1] = subaru[m - 30][j];
            }
        }
    }
    if (check(mat1)) {
        for (auto& arr : mat1) {
            for (auto& el : arr) {
                cout << el << " ";
            }
            cout << endl;
        }
    }
    else {
        for (auto& arr : mat2) {
            for (auto& el : arr) {
                cout << el << " ";
            }
            cout << endl;
        }
    }
}