#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

ll mod = 1e9 + 7;

ll pow_mod(ll a, ll b, ll mod) {
    ll curr = a;
    ll res = 1;
    while (b) {
        if (b & 1) {
            res *= curr;
            res %= mod;
        }
        curr *= curr;
        b >>= 1;
        curr %= mod;
    }
    return res;
}

void solve() {
    int n;
    cin>>n;
    string s;
    cin>>s;
    vector<ll> a(n + 1, -1), b(n + 1, -1), c(n + 1, -1);
    vector<ll> na(n + 1, -1), nb(n + 1, -1), nc(n + 1, -1);
    a[0] = 0;
    b[0] = 0;
    c[0] = 0;
    for (int i = 0; i < n;i++) {
        fill(na.begin(), na.end(), -1);
        fill(nb.begin(), nb.end(), -1);
        fill(nc.begin(), nc.end(), -1);
        if (s[i] == 'A') {
            for (int j = 0; j <= n; j++) {
                nc[j] = max(nc[j], c[j] >= 0 ? c[j] + j : -1);
                if (j < n) na[j + 1] = max(na[j + 1], a[j]);
                na[1] = max(na[1], b[j]);
                na[1] = max(na[1], c[j]);
            }
        }
        else if (s[i] == 'B') {
            for (int j = 0; j <= n; j++) {
                na[j] = max(na[j], a[j] >= 0 ? a[j] + j : -1);
                if (j < n) nb[j + 1] = max(nb[j + 1], b[j]);
                nb[1] = max(nb[1], a[j]);
                nb[1] = max(nb[1], c[j]);
            }
        }
        else {
            for (int j = 0; j <= n; j++) {
                nb[j] = max(nb[j], b[j] >= 0 ? b[j] + j : -1);
                if (j < n) nc[j + 1] = max(nc[j + 1], c[j]);
                nc[1] = max(nc[1], a[j]);
                nc[1] = max(nc[1], b[j]);
            }
        }
        swap(a, na);
        swap(b, nb);
        swap(c, nc);
        // for (auto& el : a) {
        //     cout << el << " ";
        // }
        // cout << endl;
        // for (auto& el : b) {
        //     cout << el << " ";
        // }
        // cout << endl;
        // for (auto& el : c) {
        //     cout << el << " ";
        // }
        // cout << endl;
        // cout << "-----------" << endl;
    }
    ll res = 0;
    for (auto& el : a) {
        res = max(res, el);
    }
    for (auto& el : b) {
        res = max(res, el);
    }
    for (auto& el : c) {
        res = max(res, el);
    }
    cout << res << endl;
}


int main() {
    // freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t;
    cin>>t;
    while (t) {
        solve();
        t--;
    }
}