#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

ll mod = 1e9 + 7;

ll pow_mod(ll a, ll b, ll mod) {
    ll curr = a;
    ll res = 1;
    while (b) {
        if (b & 1) {
            res *= curr;
            res %= mod;
        }
        curr *= curr;
        b >>= 1;
        curr %= mod;
    }
    return res;
}

int N = 1e5 + 5;
vector<bool> is_prime(N, true);

void solve() {
    int n, k;
    cin>>n>>k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin>>a[i];
    }
    ll res = 1e9;
    vector<vector<int>> ans;
    for (int i = 0; i < 4; i++) {
        for (int j = 0; j < 4; j++) {
            for (int k = 0; k < 4; k++) {
                for (int z = 0; z < 4; z++) {
                    vector<ll> sm(4, 0);
                    vector<vector<int>> cres(4);
                    vector<int> tp = {i, j, k, z};
                    for (int ind = 0; ind < 4; ind++) {
                        sm[tp[ind]] += a[ind];
                        cres[tp[ind]].push_back(a[ind]);
                    }
                    if (cres.size() != k) {
                        continue;
                    }
                    int cnt = 0;
                    for (auto& el : sm) {
                        if (is_prime[el]) {
                            cnt++;
                        }
                    }
                    if (cnt < res) {
                        res = cnt;
                        ans = cres;
                    }
                }
            }
        }
    }
    cout << res << endl;
    for (auto& arr : ans) {
        if (arr.empty()) {
            continue;
        }
        cout << arr.size() << " ";
        for (auto& el : arr) {
            cout << el << " ";
        }
        cout << endl;
    }
}


int main() {
    // freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    for (ll i = 2; i < N; i++) {
        if (!is_prime[i]) {
            continue;
        }
        for (ll j = i * i; j < N; j += i) {
            is_prime[j] = false;
        }
    }

    int t;
    cin>>t;
    while (t) {
        solve();
        t--;
    }
}