#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <math.h>
#define LLI long long int

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    vector<pair<int, int>> pairs;
    vector<int> dist;
    pair<int, int> swap;
    int n, i, a, b, res = 0, m1, m2;
    cin >> n;
    for (i = 0; i < n * 2; i++) {
        cin >> a >> b;
        pairs.push_back({a, b});
    }
    sort(pairs.begin(), pairs.end());
    for (i = 0; i < n * 2; i += 2) {
        if (i + 2 != n * 2 && pairs[i + 1].first == pairs[i + 2].first) {
            /*
            m1 = max(pairs[i + 1].first - pairs[i].first + (pairs[i + 1].second ^ pairs[i].second), pairs[i + 3].first - pairs[i + 2].first + (pairs[i + 3].second ^ pairs[i + 2].second));
            m2 = max(pairs[i + 2].first - pairs[i].first + (pairs[i + 2].second ^ pairs[i].second), pairs[i + 3].first - pairs[i + 1].first + (pairs[i + 3].second ^ pairs[i + 1].second));
            */
            m1 = pairs[i + 1].first - pairs[i].first + (pairs[i + 1].second ^ pairs[i].second);
            m2 = pairs[i + 2].first - pairs[i].first + (pairs[i + 2].second ^ pairs[i].second);
            dist.push_back(min(m1, m2));
            res = max(res, min(m1, m2));
            if (res == m2) {
                swap = pairs[i + 1];
                pairs[i + 1] = pairs[i + 2];
                pairs[i + 2] = swap;
            }
        }
        else {
            res = max(res, pairs[i + 1].first - pairs[i].first + (pairs[i + 1].second ^ pairs[i].second));
            dist.push_back(pairs[i + 1].first - pairs[i].first + (pairs[i + 1].second ^ pairs[i].second));
        }
    }
    for (i = 0; i < n * 2; i += 2) {
        if (i + 2 != n * 2 && pairs[i + 1].first == pairs[i + 2].first && pairs[i].second == pairs[i + 1].second) {
            if (dist[i / 2] + 1 <= res && dist[i / 2 + 1] - 1 <= res) {
                dist[i / 2]++;
                dist[i / 2 + 1]--;
                res = max(dist[i / 2 + 1], dist[i / 2]);
            }
        }
        else if (i + 2 != n * 2 && pairs[i + 1].first == pairs[i + 2].first && pairs[i].second == pairs[i + 1].second) {
            if (dist[i / 2] - 1 <= res && dist[i / 2 + 1] + 1 <= res) {
                dist[i / 2]--;
                dist[i / 2 + 1]++;
                res = max(dist[i / 2 + 1], dist[i / 2]);
            }
        }
    }
    cout << res;
}
