#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

ll cor(ll n, vector<pair<ll, ll>> a){
    vector<ll> vec;

    for(int i = 0; i < 2 * n; i++)
        vec.push_back(i);

    ll ans = (ll)(1e18);

    do{
        ll res = 0;

        for(int i = 0; i < 2 * n; i += 2){
            auto p1 = a[vec[i]], p2 = a[vec[i + 1]];
            res = max(res, abs(p1.first - p2.first) + abs(p1.second - p2.second));
        }

        ans = min(ans, res);
    } while(next_permutation(vec.begin(), vec.end()));

    return ans;
}

bool check(vector<pair<ll, ll>> a, ll can){
    set<pair<ll, ll>> vec;

    for(auto i: a){
        if(vec.empty()){
            vec.insert(i);
            continue;
        }

        // find best

        pair<ll, ll> best = {(ll)(1e18), -1};
        for(auto j: vec){
            if(abs(j.first - i.first) + abs(j.second - i.second) <= can){
                if(j.first < best.first || (j.first == best.first && j.second == i.second))
                    best = j;
            }
        }

        if(best.second == -1)
            vec.insert(i);
        else{
            vec.erase(vec.find(best));
        }
    }

    return (vec.empty());
}

bool const local = false;

int main(){
    srand(time(0));

    ll test = (local ? 1000 : 1);

    while(test--){

    ll n;
    if(!local)
        cin >> n;
    else
        n = 1 + rand() % 3;

    vector<pair<ll, ll>> a(2 * n);
    for(auto &i: a){
        if(!local)
            cin >> i.first >> i.second;
        else{
            i.first = rand() % 5;
            i.second = rand() % 2;
        }
    }

    sort(a.begin(), a.end());
    multiset<pair<ll, ll>> st;
    for(auto i: a)
        st.insert(i);

    ll ans = 0;

    while(!st.empty()){
        auto v = *st.begin();
        st.erase(st.begin());

        auto can = *st.begin();
        auto can2 = st.upper_bound(can);

        if(can2 == st.end()){
            ans = max(ans, abs(v.first - can.first) + abs(v.second - can.second));
            st.erase(st.begin());

            continue;
        }

        if(can2->first == can.first && can2->second == v.second){
            ans = max(ans, abs(v.first - can2->first) + abs(v.second - can2->second));
            st.erase(can2);

            continue;
        }

        ans = max(ans, abs(v.first - can.first) + abs(v.second - can.second));
        st.erase(st.begin());
    }

    ll need = cor(n, a);

    if(ans != need){
        cout << n << endl;

        for(auto i: a)
            cout << i.first << ' ' << i.second << endl;

        cout << ans << ' ' << need << endl;

        return 0;
    }

    if(!local)
        cout << ans << endl;

    }

    return 0;
}
