#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<ll> get(ll r){
    vector<ll> vec;

    if(r % 3 == 1)
        vec.push_back(0);

    ll need = r / 3;
    if(r % 3 == 2)
        need++;

    for(int i = 0; i < need; i++){
        vec.push_back(1);
        vec.push_back(1);
        vec.push_back(0);
    }

    if(r % 3 == 2)
        vec.pop_back();

    return vec;
}

void print(vector<vector<ll>> a){
    for(auto i: a){
        for(auto j: i)
            cout << j << ' ';
        cout << endl;
    }
}

vector<vector<ll>> get(ll n, ll m){
    vector<vector<ll>> ans(n, vector<ll> (m));
    auto c = get(n), c2 = get(n - 2);

    ll need = m / 4;
    if(m % 4 == 3)
        need++;
    else if(m % 4 == 1){
        for(int i = 0; i < n; i++)
            ans[i][0] = c[i];
    }

    ll start = (m % 4 == 1);

    for(int p = 0; p < need; p++){
        for(int j = start; j < min(m, start + 4); j++){
            if((j - start) % 2 == 0){
                for(int i = 0; i < n; i++)
                    ans[i][j] = 2;
            }
            else if(j == m - 1 || j == start + 3){
                for(int i = 0; i < n; i++)
                    ans[i][j] = c[i];
            }
            else{
                ans[0][j] = ans[n - 1][j] = 2;

                for(int i = 1; i < n - 1; i++)
                    ans[i][j] = c2[i - 1];
            }
        }

        start += 4;
    }

    return ans;
}

int main(){
    ll n, m;
    cin >> n >> m;

    if(n == 1){
        print({get(m)});
        return 0;
    }

    vector<vector<ll>> ans(n, vector<ll> (m));
    auto c = get(n), c2 = get(n - 2);

    if(n == 2 || m == 2){
        bool swapped = (m == 2);
        if(m == 2)
            swap(n, m);

        ans.clear();
        ans.resize(n, vector<ll> (m));

        ll start = (m % 3 == 1);

        if(m % 3 == 1)
            ans[0][0] = ans[1][0] = 1;

        while(start < m){
            for(int j = start; j < min(m, start + 3); j++){
                if(j - start <= 1)
                    ans[0][j] = ans[1][j] = 2;
                else
                    ans[0][j] = ans[1][j] = 1;
            }

            start += 3;
        }

        if(swapped){
            for(int j = 0; j < m; j++){
                cout << ans[0][j] << ' ' << ans[1][j] << endl;
            }

            return 0;
        }

        print(ans);
        return 0;
    }

    if(m % 4 == 2){
        auto can = get(n, m - 2);

        for(int i = 0; i < n; i++)
            for(int j = 0; j < m - 2; j++)
                ans[i][j] = can[i][j];

        if(can[0][m - 3] == 0){
            ll start = 0;

            while(start < n){
                for(int i = start; i < min(m, start + 3); i++){
                    if(i == start)
                        ans[i][m - 2] = ans[i][m - 1] = 1;
                    else
                        ans[i][m - 2] = ans[i][m - 1] = 2;
                }

                start += 3;
            }
        }
        else{
            ll start = 0;

            while(start < n){
                for(int i = start; i < min(m, start + 3); i++){
                    if(i == start + 2)
                        ans[i][m - 2] = ans[i][m - 1] = 1;
                    else
                        ans[i][m - 2] = ans[i][m - 1] = 2;
                }

                start += 3;
            }
        }

        print(ans);
        return 0;
    }


    ans = get(n, m);
    print(ans);

    return 0;
}
