#include <bits/stdc++.h>

using namespace std;
typedef int ll;

bool check(char a, ll dir0, char c, ll dir1){
    return (dir0 == 0 && dir1 == 1 && ((a == 'A' && c == 'B') || (a == 'B' && c == 'C') || (a == 'C' && c == 'A')));
}

#define endl '\n'

vector<char> comp = {'B', 'C', 'A'};

ll get(ll n, string a){
    ll ans = 0;

    for(int i = 0; i < (1ll << n); i++){
        auto b = a;

        ll c = 0;

        for(int j = 0; j < n; j++)
            if((i >> j) % 2 == 0)
                c++;

        vector<ll> dirs;
        for(int j = 0; j < n; j++)
            dirs.push_back((i >> j) & 1);

        vector<ll> same(n), dp(n);

        for(int j = n - 1; j >= 0; j--){
            if(j == n - 1)
                same[j] = 1;
            else{
                if(a[j + 1] == a[j] && dirs[j + 1] == dirs[j])
                    same[j] = same[j + 1] + 1;
                else
                    same[j] = 1;
            }
        }

        ll tot = 0;

        for(int j = n - 2; j >= 0; j--){
            if(dirs[j])
                continue;

            ll s = 0;
            if(check(a[j], dirs[j], a[j + 1], dirs[j + 1])){
                dp[j] = same[j + 1];

                s = same[j + 1];
            }

            if(j + s + 1 < n){
                ll pos = j + s + 1;

                if(a[pos] == a[j] && dirs[pos] == dirs[j])
                    dp[j] += dp[pos];
            }

            tot += dp[j];
        }

        ans = max(ans, tot);
    }

    return ans;
}

bool bad(char own, char e){
    return ((own == 'A' && e == 'B') || (own == 'B' && e == 'C') || (own == 'C' && e == 'A'));
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll t;
    cin >> t;

    while(t--){
        ll n;
        cin >> n;

        string a;
        cin >> a;

        a = "#" + a;

        vector<vector<ll>> dp(n + 1, vector<ll> (2));

        for(int i = 1; i <= n; i++){
            dp[i][0] = max(dp[i - 1][0], dp[i - 1][1]);

            ll own = 0, other = 0, cur = 0;

            for(int j = i; j >= 1; j--){
                if(bad(a[i], a[j]))
                    break;

                if(a[j] != a[i])
                    cur += own;

                dp[i][1] = max(dp[i][1], max(dp[j - 1][0], dp[j - 1][1]) + cur);

                if(a[j] == a[i])
                    own++;
                else
                    other++;
            }

        }

        cout << max(dp[n][0], dp[n][1]) << endl;
    }

    return 0;
}
/*
1
5
ABCCA

*/
