#include <iostream>
#include <vector>
#include <algorithm>>
#include <map>
#include <set>
using namespace std;



int main() {
    int n;
    cin >> n;

    set<int> points;
    map<int,pair<int,int>> map;
    for (int i = 0; i < 2*n; i++) {
        int x,y;
        cin >> x >> y;
        points.insert(x);
        if (y == 1) {
            map[x].second++;
        }
        else {
            map[x].first++;
        }
    }

    // sort(points.begin(), points.end());

    int m = 0;
    vector<pair<int,int>> wait;

    for (const int x : points) {
        int one_count = map[x].first;
        int zero_count = map[x].second;
        // cout << one_count << " " << zero_count << endl;


        if (!wait.empty() && one_count+zero_count != 0) {
            if (wait[0].second == 0) {
                if (zero_count != 0) {
                    int dist = abs(wait[0].first - x);
                    m = max(dist, m);
                    zero_count--;
                }
                else {
                    int dist = abs(wait[0].first - x) + 1;
                    m = max(dist, m);
                    one_count--;
                }
            }
            else {
                if (one_count != 0) {
                    int dist = abs(wait[0].first - x);
                    m = max(dist, m);
                    one_count--;
                }
                else {
                    int dist = abs(wait[0].first - x) + 1;
                    m = max(dist, m);
                    zero_count--;
                }
            }
            wait.clear();
        }


        zero_count %= 2;
        one_count %= 2;
        if (zero_count == 1 && one_count == 1) {
            m = max(m, one_count);
        }
        else {
            if (zero_count != 0) {
                wait.push_back({x,0});
            }
            if (one_count != 0) {
                wait.push_back({x,1});
            }
        }

    }

    cout<<m<<endl;


    return 0;
}