#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
using namespace std;



int main() {
    int n;
    cin >> n;

    set<int> points;
    map<int,pair<int,int>> map;
    for (int i = 0; i < 2*n; i++) {
        int x,y;
        cin >> x >> y;
        points.insert(x);
        if (y == 1) {
            map[x].second++;
        }
        else {
            map[x].first++;
        }
    }

    // sort(points.begin(), points.end());
    vector<int> p(points.begin(), points.end());

    int m = 0;
    vector<pair<int,int>> wait;
    int size = points.size();
    int count = 0;



    for (int i = 0; i < size; i++) {
        int one_count = map[p[i]].first;
        int zero_count = map[p[i]].second;


        if (!wait.empty() && one_count+zero_count != 0) {
            if (wait[0].second == 0) {
                if (zero_count != 0) {
                    int dist = abs(wait[0].first - p[i]);
                    m = max(dist, m);
                    zero_count--;
                }
                else {
                    int dist = abs(wait[0].first - p[i]) + 1;
                    m = max(dist, m);
                    one_count--;
                }
            }
            else {
                if (one_count != 0) {
                    int dist = abs(wait[0].first - p[i]);
                    m = max(dist, m);
                    one_count--;
                }
                else {
                    int dist = abs(wait[0].first - p[i]) + 1;
                    m = max(dist, m);
                    zero_count--;
                }
            }
            wait.clear();
        }





        if (i<size-1 && one_count+zero_count!=0) {
            int index = i+1;
            int one_count1 = map[p[index]].second;
            int zero_count1 = map[p[index]].first;
            if (abs(one_count1 - zero_count1) % 2 == 1) {
                if (zero_count1 % 2 == 1) {
                    if (zero_count != 0) {
                        int dist = abs(p[index] - p[i]);
                        zero_count--;
                        map[p[index]].first--;
                    }
                    else {
                        int dist = abs(p[index] - p[i]) + 1;
                        one_count--;
                        map[p[index]].second--;
                    }
                }
                else {
                    if (one_count != 0) {
                        int dist = abs(p[index] - p[i]);
                        one_count--;
                        map[p[index]].second--;
                    }
                    else {
                        int dist = abs(p[index] - p[i]) + 1;
                        zero_count--;
                        map[p[index]].first--;
                    }
                }
            }
        }




        zero_count %= 2;
        one_count %= 2;
        if (zero_count == 1 && one_count == 1) {
            m = max(m, 1);
        }
        else if (zero_count != 0 && one_count == 0) {
            wait.push_back({p[i],0});
        }
        else if (one_count != 0 && zero_count == 0) {
            wait.push_back({p[i],1});
        }


    }

    cout<<m<<endl;


    return 0;
}