#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_set>
#include <climits>
using namespace std;

int HelpPrevious(vector<int>& p, pair<int,int>& wait, int i, map<int,pair<int,int>>& map, int& zero_count, int& one_count) {
    int m = 0;


    if (wait.first != -1 && one_count+zero_count != 0) {
        if (wait.second == 0) {
            if (zero_count != 0) {
                int dist = abs(wait.first - p[i]);
                m = max(dist, m);
                zero_count--;
            }
            else {
                int dist = abs(wait.first - p[i]) + 1;
                m = max(dist, m);
                one_count--;
            }
        }
        else {
            if (one_count != 0) {
                int dist = abs(wait.first - p[i]);
                m = max(dist, m);
                one_count--;
            }
            else {
                int dist = abs(wait.first - p[i]) + 1;
                m = max(dist, m);
                zero_count--;
            }
        }
        wait = {-1,-1};
    }

    return m;
}


int HelpNext(vector<int>& p, pair<int,int>& wait, int i, map<int,pair<int,int>>& map, int& zero_count, int& one_count) {
    int m = 0;
    int size = p.size();


    if (i<size-1 && one_count+zero_count!=0) {
        int index = i+1;

        int zero_count1 = map[p[index]].first;
        int one_count1 = map[p[index]].second;

        if (abs(one_count1 - zero_count1) % 2 == 1) {
            // cout<<zero_count<<" "<<one_count<<endl;
            // cout<<zero_count1<<" "<<one_count1<<endl;
            if (zero_count1 % 2 == 1) {
                if (zero_count != 0) {
                    int dist = abs(p[index] - p[i]);
                    zero_count--;
                    map[p[index]].first--;
                    m = max(dist, m);
                }
                else {
                    int dist = abs(p[index] - p[i]) + 1;
                    one_count--;
                    map[p[index]].second--;
                    m = max(dist, m);
                }
            }
            else {
                if (one_count != 0) {
                    int dist = abs(p[index] - p[i]);
                    one_count--;
                    map[p[index]].second--;
                    m = max(dist, m);
                }
                else {
                    int dist = abs(p[index] - p[i]) + 1;
                    zero_count--;
                    map[p[index]].first--;
                    m = max(dist, m);
                }
            }
        }


    }
    return m;
}


int dist(pair<int,int>& p1, pair<int,int>& p2) {
    return abs(p1.first - p2.first) + abs(p1.second - p2.second);
}
int main() {
    int n;
    cin >> n;

    vector<pair<int,int>> vec(2*n);
    map<int,pair<int,int>> map;
    vector<int> p(2*n);
    for (int i = 0; i < 2*n; i++) {
        int x,y;
        cin >> x >> y;
        p[i] = i;
        vec[i] = make_pair(x,y);
        if (y == 1) {
            map[x].second++;
        }
        if (y==0) {
            map[x].first++;
        }
    }
    int m = INT_MAX;
    do {
        int u = 0;
        for (int i = 0; i < 2*n; i+=2) {
            u = max(dist(vec[i],vec[i+1]),u);
        }
        m = min(m,u);
        
    }while (next_permutation(p.begin(), p.end()));

    cout<<m<<endl;






    return 0;
}