#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
const ll SIZ = ((ll)2e5+5), LONGBOI = ((ll)1e15+5);
mt19937_64 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

ll n, ans, x0size, x1size, x0pos, x1pos, xnow;
ll x0[SIZ], x1[SIZ];
ll s0, s1;
queue<pll> q;

ll getDist(pll pos1, pll pos2){
    return (abs(pos1.first-pos2.first) + abs(pos1.second-pos2.second));
}

void updateDist(pll pos1, pll pos2){
    ans = max(ans, getDist(pos1, pos2));
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    ans = 0;

    ll xread, yread;
    for(int i=1; i <= 2*n; i++){
        cin >> xread >> yread;
        if(yread == 0){
            x0size++;
            x0[x0size] = xread;
        }
        else{
            x1size++;
            x1[x1size] = xread;
        }
    }

    sort(x0+1,x0+1+x0size);
    sort(x1+1,x1+1+x1size);

    x0[x0size+1] = LONGBOI;
    x1[x1size+1] = LONGBOI;
    x0pos = 1; x1pos = 1;
    ll d0, d1;
    pll add, v;
    while(x0pos <= x0size || x1pos <= x1size){
        xnow = min(x0[x0pos], x1[x1pos]);
        s0 = 0; s1 = 0;

        while(x0pos <= x0size && x0[x0pos] == xnow) { s0++; x0pos++; }
        while(x1pos <= x1size && x1[x1pos] == xnow) { s1++; x1pos++; }

        //cout << "xnow = " << xnow << " s0 = " << s0 << " s1 = " << s1 << " q size = " << q.size() << " ans = " << ans << endl;

        while(!q.empty() && (s0 > 0 || s1 > 0)){
            v = q.front(); q.pop();
            d0 = getDist({xnow, 0}, v);
            d1 = getDist({xnow, 1}, v);

            if(s0 > 0 && s1 <= 0){
                s0--;
                updateDist({xnow, 0}, v);
            }
            else if(s1 > 0 && s0 <= 0){
                s1--;
                updateDist({xnow, 1}, v);
            }
            else{
                if(d0 < d1){
                    s0--;
                    updateDist({xnow, 0}, v);
                }
                else if(d0 > d1){
                    s1--;
                    updateDist({xnow, 1}, v);
                }
                else if(d0 == d1){
                    if(s0 >= s1){
                        s0--;
                        updateDist({xnow, 0}, v);
                    }
                    else{
                        s1--;
                        updateDist({xnow, 1}, v);
                    }
                }
            }
        }

        
        if(s0 > 0) s0 = s0 % 2;
        if(s1 > 0) s1 = s1 % 2;
        
        if(s0 >= 0 && s1 >= 0){
            if(s0 == s1) { ans = max(ans, (ll)1); continue; }
            if(s0 > s1){
                s0 -= s1; s1 = 0;
                add = {xnow,0};
            }
            else{
                s1 -= s0; s0 = 0;
                add = {xnow,1};
            }
        }

        while(s0 > 0 || s1 > 0){
            q.push(add);
            s0--;
            s1--;
        }
    }
    cout << ans << endl;
    return 0;
}
