#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
const ll SIZ = ((ll)1e6+5), LONGBOI = ((ll)1e15+5);
mt19937_64 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

ll n, k;
ll a[SIZ];

bool Prost(ll x){
    if(x == 2) return true;
    if(x % 2 == 0) return false;
    for(int i=3; i <= sqrt(x); i++){
        if(x % i == 0) return false;
    }
    return true;
}

pair<ll, vector<ll>> dfs(vector<ll> v){
    if(v.size() >= n){
        ll sum[5];
        for(int i=1; i <= k; i++) sum[i] = 0;
        for(int i=0; i<v.size();i++){
            sum[v[i]] += a[i+1];
        }

        pair<ll, vector<ll>> ans = { 0, v};
        for(int i=1; i <= k; i++){
            if(sum[i] <= 0){
                ans.first = LONGBOI;
                return ans;
            }
        }

        for(int i=1; i <= k; i++){
            if(Prost(sum[i]))ans.first++;
        }
        return ans;
    }

    pair<ll, vector<ll>> ans, res; ans.first = LONGBOI;
    for(int i=1; i <= k; i++){
        v.push_back(i);
        res = dfs(v);
        v.pop_back();
        if(res.first < ans.first) ans = res;
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll T;
    vector<ll> v;
    pair<ll, vector<ll>> ans;
    map<ll, vector<ll>> m;
    cin >> T;
    while(T > 0){
        T--;
        cin >> n >> k;
        for(int i=1; i<=n; i++){
            cin >> a[i];
        }

        v.clear();
        ans = dfs(v);
        cout << ans.first << endl;
        m.clear();
        for(int i=0; i < ans.second.size(); i++){
            m[ans.second[i]].push_back(a[i+1]);
        }
        for(int i=1; i <= k; i++){
            cout << m[i].size() << " ";
            for(auto x : m[i]) cout << x << " ";
            cout << endl;
        }
    }
    return 0;
}
