#include <bits/stdc++.h>

using namespace std;

#define print(a) cerr << "[" << #a << " = " << (a) << "] "
#define dbg(a) print(a) << "\n"
#define dbg2(a, b) print(a); print(b) << "\n"
#define dbg3(a, b, c) print(a); print(b); print(c) << "\n"

#define int long long
#define ll long long
#define pi pair<int, int> 
#define sz(a) ((int)(a).size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define divup(a, b) (((a) + (b) - 1) / (b))

template <class T> bool chmax(T&a, const T&b) {return b > a ? a = b, 1 : 0;};
template <class T> bool chmin(T&a, const T&b) {return b < a ? a = b, 1 : 0;};

template <class T> using min_queue = priority_queue<T, vector<T>, greater<T>>;
template <class T> using max_queue = priority_queue<T, vector<T>, less<T>>;

const int mod = 1e9 + 7;
const int inf = (int)(1e18) + 7;
const int maxn = 2e5 + 7;
const int logn = 20;

map <int, int> mp[2];

void solve() {
    int n;
    cin >> n;
    n *= 2; 

    vector <pi> a(n);
    vector <int> b;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        b.push_back(a[i].first);
        mp[a[i].second][a[i].first]++;
        if (mp[a[i].second][a[i].first] > 2) mp[a[i].second][a[i].first] -= 2;
    }
    sort(all(b));
    b.resize(unique(all(b)) - b.begin());

    int px = -1, py = -1;
    for (auto x : b) {
        int cnt0 = mp[0][x];
        int cnt1 = mp[1][x];
        dbg2(cnt0, cnt1);
        if (py != -1) {
            if (py == 0) {
                if (cnt0) {
                    --cnt0;
                    ans = max(ans, x - px);
                } else {
                    --cnt1;
                    ans = max(ans, x - px + 1);
                }
            } else {
                if (cnt1) {
                    --cnt1;
                    ans = max(ans, x - px);
                } else {
                    --cnt0;
                    ans = max(ans, x - px + 1);
                }
            }
            py = -1;
        }
        if (cnt0 == 2 && cnt1 == 2) {
            chmax(ans, 1LL);
        }
        if (cnt0 > 0 && cnt1 > 0) {
            --cnt0;
            --cnt1;
            chmax(ans, 1LL);
        }
        if (cnt0 == 2 || cnt1 == 2) {
            cnt0 = cnt1 = 0;
        }
        if (cnt0 == 1) {
            px = x;
            py = 0;
        } else if (cnt1 == 1) {
            px = x;
            py = 1;
        }
    }
    cout << ans << '\n';
    return;

    // sort(all(a));
    // for (int i = 0; i + 1 < n; i += 2) {
    //     chmax(ans, a[i + 1].first - a[i].first + (a[i].second != a[i + 1].second));
    // }
    // cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
    freopen("error.txt", "w", stderr);

    solve();
}