#include <bits/stdc++.h>

using namespace std;

#define print(a) cerr << "[" << #a << " = " << a << "] "
#define dbg(a) print(a) << "\n"
#define dbg2(a, b) print(a); print(b) << "\n"
#define dbg3(a, b, c) print(a); print(b); print(c) << "\n"

#define int long long
#define ll long long
#define pi pair<int, int> 
#define sz(a) ((int)(a).size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define divup(a, b) (((a) + (b) - 1) / (b))

template <class T> bool chmax(T&a, const T&b) {return b > a ? a = b, 1 : 0;};
template <class T> bool chmin(T&a, const T&b) {return b < a ? a = b, 1 : 0;};

template <class T> using min_queue = priority_queue<T, vector<T>, greater<T>>;
template <class T> using max_queue = priority_queue<T, vector<T>, less<T>>;

const int mod = 1e9 + 7;
const int inf = (int)(1e18) + 7;
const int maxn = 2e5 + 7;
const int logn = 20;


void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;

    auto check = [&](int i) {
        if (s[i] == 'B' && s[i] == 'A') return 0;
        if (s[i] == 'C' && s[i] == 'B') return 0;
        if (s[i] == 'A' && s[i] == 'C') return 0;
        return 1;
    };

    int cnta = 0, cntb = 0, cntc = 0, ans = 0;
    for (int i = 0; i < n; ++i) {
        cnta += (s[i] == 'A');
        cntb += (s[i] == 'B');
        cntc += (s[i] == 'C');
        if (i == n - 1 || !check(i)) {
            ans += max(cntb * cnta, cntc * cntb);
            cnta = cntb = cntc = 0;
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
    freopen("error.txt", "w", stderr);

    int t;
    cin >> t;
    while (t--) {
        solve();
        cerr << "###############";
    }
}