#include <bits/stdc++.h>

using namespace std;

#define print(a) cerr << "[" << #a << " = " << a << "] "
#define dbg(a) print(a) << "\n"
#define dbg2(a, b) print(a); print(b) << "\n"
#define dbg3(a, b, c) print(a); print(b); print(c) << "\n"

#define int long long
#define ll long long
#define pi pair<int, int> 
#define sz(a) ((int)(a).size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define divup(a, b) (((a) + (b) - 1) / (b))

template <class T> bool chmax(T&a, const T&b) {return b > a ? a = b, 1 : 0;};
template <class T> bool chmin(T&a, const T&b) {return b < a ? a = b, 1 : 0;};

template <class T> using min_queue = priority_queue<T, vector<T>, greater<T>>;
template <class T> using max_queue = priority_queue<T, vector<T>, less<T>>;

const int mod = 1e9 + 7;
const int inf = (int)(1e18) + 7;
const int maxn = 2e5 + 7;
const int logn = 20;


void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;

    vector<int> b, c;
    for (int i = 0; i < n; ++i) {
        if (i == 0 || s[i] != s[i - 1]) {
            if (s[i] == 'A') b.push_back(0);
            else if (s[i] == 'B') b.push_back(1);
            else b.push_back(2);
            c.push_back(1);
        } else {
            c.back()++;
        }
    }
    n = sz(b);

    int ans = 0;
    for (int msk = 0; msk < 1 << n; ++msk) {
        vector <int> bb = b, cc = c;
        int cur = 0;
        dbg(msk);
        for (int i = 0; i < n; ++i) {
            if (msk >> i & 1) {
                dbg(i);
                for (int j = i; j > 0; --j) {
                    if ((bb[j - 1] + 1) % 2 == bb[j]) {
                        cur += cc[j - 1] * cc[j];
                        dbg(cur);
                        swap(cc[j], cc[j - 1]);
                        swap(bb[j], bb[j - 1]);
                    }
                }
            }
        }
        chmax(ans, cur);
    }

    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
    freopen("error.txt", "w", stderr);

    int t;
    cin >> t;
    while (t--) {
        solve();
        cerr << "###############";
    }
}