
#include<iostream>
#include <vector>
using namespace std;


struct Point {
    int x, y;
};


vector<Point> bubleSort(vector<Point> &v) {
    bool b = true;
    while (b) {
        b = false;
        for (int i = 0; i < v.size() - 1; i++) {
            if (v[i].x > v[i + 1].x) {
                Point a = v[i + 1];
                v[i + 1] = v[i];
                v[i] = a;
                b = true;
            }
        }
    }
    return v;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<Point> q (n*2);
    for (int i = 0; i < n*2; i++)
        cin >> q[i].x >> q[i].y;

    bubleSort(q);
    vector<int> minQ (n);
    for (int i = 0; i < n*2; i+=2) {
        minQ[i/2] = abs(q[i].x - q[i+1].x) + abs(q[i].y - q[i+1].y);
    }

    // for (int i : minQ)
    //     cout << i << " ";
    // cout << endl;

    int max = 0;
    for (int i : minQ) {
        if (max < i)
            max = i;
    }
    cout << max << endl;
    return 0;
}