from itertools import permutations
import sys
n = int(sys.stdin.readline())
points = []
for _ in range(2 * n):
    points.append(tuple(map(int, sys.stdin.readline().split())))

min_max_distance = float('inf')
for permutation in permutations(points):
    max_distance = 0
    for i in range(n):
        p1 = permutation[2*i]
        p2 = permutation[2*i+1]
        distance = abs(p1[0]-p2[0]) + abs(p1[1]-p2[1])
        max_distance = distance if distance > max_distance else max_distance
    min_max_distance = max_distance if max_distance < min_max_distance else min_max_distance

print(min_max_distance)
