#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;

#define int long long

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

bool cmp(pair<int, int>& p1, pair<int, int>& p2) {
    if(p1.first < p2.first) return true;
    if(p1.first > p2.first) return false;
    return p1.second < p2.second;
}

void solve() {
    int n;
    cin >> n;
    vector< pair<int, int> > vt(2 * n);
    for(int i = 0; i < 2 * n; ++i) {
        cin >> vt[i].first >> vt[i].second;
    }
    sort(vt.begin(), vt.end(), cmp);
    int ans = 0;
    for(int i = 1; i < 2 * n; i += 2) {
        ans = max(ans, abs(vt[i].first - vt[i - 1].first) + abs(vt[i].second - vt[i - 1].second));
        cout << abs(vt[i].first - vt[i - 1].first) << ' ' << abs(vt[i].second - vt[i - 1].second) << '\n';
    }
    for(auto& i: vt) {
        cout << i.first << ' ' << i.second << '\n';
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int tt = 1;
    //cin >> tt;
    while(tt--) {
        solve();
    }
}
