#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;

#define int long long

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

bool cmp(pair<int, int>& p1, pair<int, int>& p2) {
    if(p1.first < p2.first) return true;
    if(p1.first > p2.first) return false;
    return p1.second < p2.second;
}

bool rcmp(pair<int, int>& p1, pair<int, int>& p2) {
    if(p1.first < p2.first) return !true;
    if(p1.first > p2.first) return !false;
    return !(p1.second < p2.second);
}

void solve() {
    int n;
    cin >> n;
    map<int, vector<int>> mp;
    for(int i = 0; i < 2 * n; ++i) {
        int x, y;
        cin >> x >> y;
        mp[x].emplace_back(y);
    }
    vector<pair<int, int>> vt;
    int ind = 0;
    for(auto& i : mp) {
        vector<int> vtt = i.second;
        if(ind % 2 == 0) sort(vtt.begin(), vtt.end());
        else sort(vtt.rbegin(), vtt.rend());
        for(auto& j : vtt) {
            vt.emplace_back(make_pair(i.first, j));
        }
        ++ind;
    }
    int ans = 0;
    for(int i = 1; i < 2 * n; i += 2) {
        ans = max(ans, abs(vt[i].first - vt[i - 1].first) + abs(vt[i].second - vt[i - 1].second));
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int tt = 1;
    //cin >> tt;
    while(tt--) {
        solve();
    }
}
