#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

ll dist(const pair<ll,ll> &first,const pair<ll,ll> &second){
    return abs(first.first-second.first)+abs(first.second-second.second);
}

void chmyax(ll &a, ll b){
    a=max(a,b);
}
void chmyin(ll &a, ll b){
    a=min(a,b);
}
void mapchmyin(map<pair<ll,ll>,ll> &mp, pair<ll,ll> key, ll value){
    auto it = mp.find(key);
    if (it==mp.end()){
        mp.insert({key,value});
    }else{
        chmyin(it->second, value);
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n,m,a,b,c,d;
    cin>>n;
    vector<ll> bot;
    vector<ll> top;
    for (ll i=0;i<2*n;i++){
        cin>>a>>b;
        if (b==0){
            bot.push_back(a);
        }else{
            top.push_back(a);
        }
    }
    sort(all(bot));
    sort(all(top));
    a=bot.size();
    b=top.size();
    map<pair<ll,ll>,ll> dp;
    dp[{0,0}]=1;
    for (ll i=0;i<=a;i++){
        for (ll j=0;j<=b;j++){
            if (i>1){
                auto it = dp.find({i-2,j});
                if (it!=dp.end()){
                    mapchmyin(dp, {i,j}, max(it->second,bot[i-1]-bot[i-2]));
                }
            }
            if (j>1){
                auto it = dp.find({i,j-2});
                if (it!=dp.end()){
                    mapchmyin(dp, {i,j}, max(it->second,top[j-1]-top[j-2]));
                }
            }
            if (i>0 && j>0){
                auto it = dp.find({i-1,j-1});
                if (it!=dp.end()){
                    mapchmyin(dp, {i,j}, max(it->second,abs(bot[i-1]-top[j-1])+1));
                }
            }
        }
    }
    cout<<dp[{a,b}];
}