import sys
from math import sqrt, pow

def getDistance(x1, y1, x2, y2):
    return (max(x1, x2) - min(x1, x2)) + (max(y1, y2) - min(y1, y2))

n = int(sys.stdin.readline())

allPoints = list()

for i in range(n*2): 
    allPoints.append([list(map(int, sys.stdin.readline().split())), False])

pairs = list()

for i in range(len(allPoints)):
    x, y = allPoints[i][0][0], allPoints[i][0][1]
    allPoints[i][1] = True
    firstFound = False
    indexPair = None
    for j in range(len(allPoints)):
        if not allPoints[j][1]:
            if not firstFound:
                indexPair = j
                firstFound = True
            else:
                if getDistance(x, y, allPoints[indexPair][0][0], allPoints[indexPair][0][1]) > getDistance(x, y, allPoints[j][0][0], allPoints[j][0][1]):
                    indexPair = j
    
    if firstFound:
        allPoints[indexPair][1] = True
        pairs.append([[x, y], [allPoints[indexPair][0][0], allPoints[indexPair][0][1]]])

lowestDistance = getDistance(pairs[0][0][0], pairs[0][0][1], pairs[0][1][0], pairs[0][1][1])


for i in pairs[1::]:
    distance = getDistance(i[0][0], i[0][1], i[1][0], i[1][1])
    if lowestDistance > distance:
        lowestDistance = distance
print(lowestDistance)