#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <numeric>
#include <climits>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <cstdint>
using namespace std;

struct Point
{
    int x, y;

    friend bool operator<(const Point& p1, const Point& p2)
    {
        if (p1.x < p2.x)
        {
            return 1;
        }
        if (p1.x > p2.x) return 0;
        return p1.y < p2.y;
    }
};

void solve()
{
    int n;
    cin >> n;
    vector<Point> P(2*n);

    int mx_y = 0;
    for (int i=0; i<P.size(); i++)
    {
        cin >> P[i].x >> P[i].y;
        mx_y = max(mx_y, P[i].y);
    }

    sort(P.begin(), P.end());

    if (n == 1)
    {
        cout << abs(P[0].x-P[1].x) + abs(P[0].y-P[1].y);
        return;
    }

    if (P[0].x == P[2*n-1].x)
    {
        cout << mx_y << endl;
        return;
    }
}

int main()
{
    solve();
}