#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <numeric>
#include <climits>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <cstdint>
using namespace std;

void solve()
{
    int n;
    cin >> n;
    string s;
    cin >> s;

    // G2
    if (s == "ABB" || s == "BCC" || s == "CAA" ||
        s == "AAB" || s == "BBC" || s == "CCA")
    {
        cout << 2 << endl;
        return;
    }

    // G3
    bool g3 = 1;
    for (char i : s)
    {
        if (i == 'C')
        {
            g3 = 0;
            break;
        }
    }
    if (g3)
    {
        int a_count = 0;
        long long res = 0;
        for (char i : s)
        {
            if (i == 'A') a_count++;
            else if (i == 'B')
            {
                res += a_count;
            }
        }
        cout << res << endl;
        return;
    }

    // G4

    // long long res1 = 0;
    // int a_count = 0;
    // int b_count = 0;
    // int c_count = 0;
    // bool flagb = 1;
    // bool flagc = 0;
    // for (char i : s)
    // {
    //     if (i == 'A') a_count++;
    //     if (i == 'B')
    //     {
    //         b_count++;
    //     }
    //     if (flagb && i == 'B')
    //     {
    //         res1 = a_count;
    //         flagb = 0;
    //         flagc = 1;
    //     }
    //     if (i == 'C')
    //     {
    //         c_count++;
    //     }
    //     if (flagc && i == 'C')
    //     {
    //         res1 *= b_count;
    //         flagc = 0;
    //     }
    // }

    // long long res2 = (long long)b_count * c_count;

    // cout << max(res1, res2) << endl;
    // return;

    // G5

    int a_count = 0;
    int c_continuous = 0;
    int b_buffer = 0;
    long long res1 = 0;
    long long res2 = 0;

    bool c_span = 0;
    for (char i : s)
    {
        if (i == 'C')
        {
            c_span = 1;
            res2 += b_buffer;
            a_count = 0;
        }
        // else
        // {
        //     res2 += b_continuous * c_continuous;
        //     c_continuous = 0;
        // }

        if (i == 'A')
        {
            a_count++;
            b_buffer = 0;
            c_span = 0;
        }

        if (i == 'B')
        {
            if (c_span == 0)
            {
                b_buffer++;
                res1 += a_count;
            }
            else
            {
                b_buffer = 0;
                c_span = 0;
            }
        }
    }
    cout << max(res1, res2) << endl;
    return;

    // G1
    string temp;
    for (int i=1; i<n; i++)
    {
        temp = "";
        temp += s[i-1];
        temp += s[i];

        if (temp == "AB" || temp == "BC" || temp == "CA")
        {
            cout << 1 << endl;
            return;
        }
    }
    cout << 0 << endl;
}

int main()
{
    int t;
    cin >> t;
    while (t--) solve();
}