#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <numeric>
#include <climits>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <cstdint>
using namespace std;

bool isPrime(int64_t x)
{
    int64_t to = sqrt(x);
    for (int i=2; i<=to; i++)
    {
        if (x%i == 0) return 0;
    }
    return 1;
}

void solve()
{
    int n, k;
    cin >> n >> k;

    vector<int64_t> A(n);
    
    int64_t sum = 0;
    int count2 = 0;
    for (int i=0; i<n; i++)
    {
        cin >> A[i];
        sum += A[i];
        if (A[i] == 2) count2++;
    }

    if (k == 1)
    {
        if (isPrime(sum) == 0)
        {
            cout << 0 << endl;
        }
        else cout << 1 << endl;
        cout << n << " ";
        for (int64_t i : A)
        {
            cout << i << ' ';
        }
        cout << endl;
        return;
    }

    if (k == n)
    {
        cout << n << endl;
        for (int64_t i : A)
        {
            cout << "1 " << i << endl;
        }
        return;
    }

    if (n <= 4)
    {
        int64_t a1 = A[0]+A[1]+A[2];
        int64_t b1 = A[3];

        int64_t a2 = A[0]+A[1]+A[3];
        int64_t b2 = A[2];
        
        int64_t a3 = A[0]+A[2]+A[3];
        int64_t b3 = A[1];

        int64_t a4 = A[1]+A[2]+A[3];
        int64_t b4 = A[0];

        int64_t a5 = A[0]+A[1];
        int64_t b5 = A[2]+A[3];

        int64_t a6 = A[0]+A[2];
        int64_t b6 = A[1]+A[3];

        int64_t a7 = A[0]+A[3];
        int64_t b7 = A[1]+A[2];

        int mn1 = isPrime(a1) + isPrime(b1);
        int mn2 = isPrime(a2) + isPrime(b2);
        int mn3 = isPrime(a3) + isPrime(b3);
        int mn4 = isPrime(a4) + isPrime(b4);
        int mn5 = isPrime(a5) + isPrime(b5);
        int mn6 = isPrime(a6) + isPrime(b6);
        int mn7 = isPrime(a7) + isPrime(b7); 
    
        int mn = min(mn1, mn2);
        mn = min(mn, mn3);
        mn = min(mn, mn4);
        mn = min(mn, mn5);
        mn = min(mn, mn6);
        mn = min(mn, mn7);
        

        cout << mn << endl;
        if (mn1 == mn)
        {
            cout << "3 " << A[0] << ' ' << A[1] << ' ' << A[2] << endl;
            cout << "1 " << A[3] << endl;
        }
        else if (mn2 == mn)
        {
            cout << "3 " << A[0] << ' ' << A[1] << ' ' << A[3] << endl;
            cout << "1 " << A[2] << endl;
        }
        else if (mn3 == mn)
        {
            cout << "3 " << A[0] << ' ' << A[2] << ' ' << A[3] << endl;
            cout << "1 " << A[1] << endl;
        }
        else if (mn4 == mn)
        {
            cout << "3 " << A[1] << ' ' << A[2] << ' ' << A[3] << endl;
            cout << "1 " << A[0] << endl;
        }
        else if (mn5 == mn)
        {
            cout << "2 " << A[0] << ' ' << A[1] << endl;
            cout << "2 " << A[2] << ' ' << A[3] << endl;
        }
        else if (mn6 == mn)
        {
            cout << "2 " << A[0] << ' ' << A[2] << endl;
            cout << "2 " << A[1] << ' ' << A[3] << endl;
        }
        else if (mn7 == mn)
        {
            cout << "2 " << A[0] << ' ' << A[3] << endl;
            cout << "2 " << A[1] << ' ' << A[2] << endl;
        }
        return;
    }
}

int main()
{
    int t;
    cin >> t;
    while (t--) solve();   
}